Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var RTG = require("react-transition-group");
var React_1 = require("../../React");
var AlertView_1 = require("./AlertView");
var AlertHostView = /** @class */ (function (_super) {
    tslib_1.__extends(AlertHostView, _super);
    function AlertHostView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AlertHostView.prototype.updateOn = function (viewModel) {
        return [viewModel.alerts.changed];
    };
    AlertHostView.prototype.render = function () {
        var _a = this.restProps(), className = _a.className, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('AlertHost', className) }),
            React.createElement(RTG.TransitionGroup, null, this.renderAlerts())));
    };
    AlertHostView.prototype.renderAlerts = function () {
        return this.viewModel.alerts.value.map(function (x) { return (React.createElement(RTG.CSSTransition, { key: x.key, classNames: "alert", timeout: { enter: 500, exit: 300 } },
            React.createElement(AlertView_1.AlertView, { viewModel: x }))); });
    };
    AlertHostView.displayName = 'AlertHostView';
    return AlertHostView;
}(React_1.BaseView));
exports.AlertHostView = AlertHostView;
//# sourceMappingURL=AlertHostView.js.map