Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var Events_1 = require("../../../Events");
var PubSub_1 = require("../../../Utils/PubSub");
var React_1 = require("../../React");
var AlertViewModel_1 = require("../Alert/AlertViewModel");
var AlertHostViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(AlertHostViewModel, _super);
    function AlertHostViewModel() {
        var _this = _super.call(this) || this;
        var addAlert = _this.wx.command();
        var removeAlert = _this.wx.command();
        var events = rxjs_1.Observable.merge(addAlert.results.map(function (add) { return ({ add: add }); }), removeAlert.results.map(function (remove) { return ({ remove: remove }); }));
        _this.alerts = events
            .scan(function (alerts, event) {
            if (event.add != null) {
                return (alerts || []).concat(event.add);
            }
            else if (event.remove != null) {
                return (alerts || []).filter(function (x) { return x !== event.remove; });
            }
            throw new Error('Invalid Alert Event');
        }, undefined)
            .toProperty([], false);
        _this.addSubscription(addAlert.results
            .flatMap(function (alert) {
            return _this.wx
                .whenAny(alert.isVisible, function (isVisible) { return ({ alert: alert, isVisible: isVisible }); })
                .filter(function (x) { return x.isVisible === false; })
                .map(function (x) { return x.alert; });
        })
            .do(function (x) {
            x.unsubscribe();
        })
            .invokeCommand(removeAlert));
        _this.addSubscription(PubSub_1.Default
            .observe(Events_1.AlertCreatedKey)
            .map(function (x, i) {
            return new AlertViewModel_1.AlertViewModel(i, x.content, x.header, x.style, x.timeout);
        })
            .invokeCommand(addAlert));
        return _this;
    }
    AlertHostViewModel.displayName = 'AlertHostViewModel';
    return AlertHostViewModel;
}(React_1.BaseViewModel));
exports.AlertHostViewModel = AlertHostViewModel;
//# sourceMappingURL=AlertHostViewModel.js.map