Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var Assets_1 = require("../../../Assets");
var Routing_1 = require("../../../Routing");
var React_1 = require("../../React");
var AlertHostView_1 = require("../Alert/AlertHostView");
var PageFooterView_1 = require("../PageFooter/PageFooterView");
var PageHeaderView_1 = require("../PageHeader/PageHeaderView");
var RouteHandlerView_1 = require("../RouteHandler/RouteHandlerView");
var RouteHandlerViewModel_1 = require("../RouteHandler/RouteHandlerViewModel");
var Splash_1 = require("../Splash/Splash");
var BootstrapGuide_1 = require("./BootstrapGuide");
var NamespacedPortal_1 = require("./NamespacedPortal");
Routing_1.ViewMap[RouteHandlerViewModel_1.SplashKey] = function () { return React.createElement(Splash_1.Splash, { header: "webrx-react", logo: Assets_1.logo }); };
var AppView = /** @class */ (function (_super) {
    tslib_1.__extends(AppView, _super);
    function AppView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AppView.prototype.updateOn = function (viewModel) {
        return [viewModel.isLoading.changed];
    };
    AppView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var viewMap = x.viewMap, guide = x.guide, brand = x.brand, branduri = x.branduri, responsive = x.responsive, alerts = x.alerts, header = x.header, footer = x.footer, copyright = x.copyright, copyrightYear = x.copyrightYear, copyrightUri = x.copyrightUri, footerContent = x.footerContent, hideDimensions = x.hideDimensions;
            return {
                viewMap: viewMap,
                guide: guide,
                brand: brand,
                branduri: branduri,
                responsive: responsive,
                alerts: alerts,
                header: header,
                footer: footer,
                copyright: copyright,
                copyrightYear: copyrightYear,
                copyrightUri: copyrightUri,
                footerContent: footerContent,
                hideDimensions: hideDimensions,
            };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return (React.createElement("div", { className: "webrx-react bootstrap-3", ref: NamespacedPortal_1.updateDefaultContainer },
            React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('App', { responsive: props.responsive }, className) }), this.wxr.renderConditional(this.viewModel.isLoading, function () { return (React.createElement("i", { className: "preload fa fa-spinner fa-5x fa-pulse", "aria-hidden": "true" })); }, function () { return (React.createElement("div", null,
                _this.renderGuide(),
                _this.renderAlerts(),
                _this.renderHeader(),
                _this.renderRouteHandler(),
                _this.renderFooter())); }))));
    };
    AppView.prototype.renderGuide = function () {
        if (this.props.guide) {
            return this.props.guide === true ? React.createElement(BootstrapGuide_1.BootstrapGuide, null) : this.props.guide;
        }
        return false;
    };
    AppView.prototype.renderAlerts = function () {
        if (this.props.alerts && this.viewModel.alerts) {
            var alerts = this.props.alerts === true ? (React.createElement(AlertHostView_1.AlertHostView, { viewModel: this.viewModel.alerts })) : (this.props.alerts(this.viewModel.alerts, this.props));
            return (React.createElement("div", { className: "float-container" },
                React.createElement(react_bootstrap_1.Grid, { fluid: this.props.responsive }, alerts)));
        }
        return false;
    };
    AppView.prototype.renderHeader = function () {
        if (this.props.header && this.viewModel.header) {
            return this.props.header === true ? (React.createElement(PageHeaderView_1.PageHeaderView, { viewModel: this.viewModel.header, brand: this.props.brand, branduri: this.props.branduri, responsive: this.props.responsive })) : (this.props.header(this.viewModel.header, this.props));
        }
        return false;
    };
    AppView.prototype.renderRouteHandler = function () {
        if (this.props.routeHandler) {
            return this.props.routeHandler(this.viewModel.routeHandler, this.props);
        }
        return (React.createElement(RouteHandlerView_1.RouteHandlerView, { viewModel: this.viewModel.routeHandler, viewMap: this.props.viewMap, responsive: this.props.responsive }));
    };
    AppView.prototype.renderFooter = function () {
        if (this.props.footer && this.viewModel.footer) {
            var footerProps = {
                copyright: this.props.copyright,
                copyrightYear: this.props.copyrightYear,
                copyrightUri: this.props.copyrightUri,
                footerContent: this.props.footerContent,
                hideDimensions: this.props.hideDimensions,
            };
            return this.props.footer === true ? (React.createElement(PageFooterView_1.PageFooterView, tslib_1.__assign({ viewModel: this.viewModel.footer, responsive: this.props.responsive }, footerProps))) : (this.props.footer(this.viewModel.footer, this.props));
        }
        return false;
    };
    AppView.displayName = 'AppView';
    AppView.updateDefaultPortalContainer = NamespacedPortal_1.updateDefaultContainer;
    AppView.defaultProps = {
        viewMap: Routing_1.ViewMap,
        guide: DEBUG,
    };
    return AppView;
}(React_1.BaseView));
exports.AppView = AppView;
//# sourceMappingURL=AppView.js.map