import { RouteMapper } from '../../../Routing';
import { ObservableLike, ReadOnlyProperty } from '../../../WebRx';
import { BaseViewModel } from '../../React';
import { AlertHostViewModel } from '../Alert/AlertHostViewModel';
import { PageFooterViewModel } from '../PageFooter/PageFooterViewModel';
import { PageHeaderViewModel } from '../PageHeader/PageHeaderViewModel';
import { RouteHandlerViewModel } from '../RouteHandler/RouteHandlerViewModel';
export declare class AppViewModel extends BaseViewModel {
    static displayName: string;
    readonly alerts: AlertHostViewModel;
    readonly routeHandler: RouteHandlerViewModel;
    readonly header: PageHeaderViewModel;
    readonly footer: PageFooterViewModel;
    readonly isLoading: ReadOnlyProperty<boolean>;
    constructor(alerts?: boolean | AlertHostViewModel, header?: boolean | PageHeaderViewModel, footer?: boolean | PageFooterViewModel, isLoading?: ObservableLike<boolean>, routingMap?: RouteMapper);
}
export declare let Current: AppViewModel;
