Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var Routing_1 = require("../../../Routing");
var React_1 = require("../../React");
var AlertHostViewModel_1 = require("../Alert/AlertHostViewModel");
var PageFooterViewModel_1 = require("../PageFooter/PageFooterViewModel");
var PageHeaderViewModel_1 = require("../PageHeader/PageHeaderViewModel");
var RouteHandlerViewModel_1 = require("../RouteHandler/RouteHandlerViewModel");
// inject a default route
Routing_1.RouteMap['/'] = { path: RouteHandlerViewModel_1.SplashKey };
// setup default splash route
Routing_1.RouteMap["^/" + RouteHandlerViewModel_1.SplashKey + "$"] = { creator: function () { return RouteHandlerViewModel_1.SplashKey; } };
var AppViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(AppViewModel, _super);
    function AppViewModel(alerts, header, footer, isLoading, routingMap) {
        if (alerts === void 0) { alerts = false; }
        if (header === void 0) { header = false; }
        if (footer === void 0) { footer = false; }
        if (routingMap === void 0) { routingMap = Routing_1.RouteMap; }
        var _this = _super.call(this) || this;
        if (alerts) {
            _this.alerts = alerts === true ? new AlertHostViewModel_1.AlertHostViewModel() : alerts;
        }
        _this.routeHandler = new RouteHandlerViewModel_1.RouteHandlerViewModel(routingMap);
        if (header) {
            _this.header =
                header === true ? new PageHeaderViewModel_1.PageHeaderViewModel(_this.routeHandler) : header;
        }
        if (footer) {
            _this.footer = footer === true ? new PageFooterViewModel_1.PageFooterViewModel() : footer;
        }
        _this.isLoading = _this.wx.getProperty(isLoading ||
            rxjs_1.Observable.of(false)
                // this is a micro delay for the preloader to prevent FOUC
                .delay(100));
        exports.Current = _this;
        return _this;
    }
    AppViewModel.displayName = 'AppViewModel';
    return AppViewModel;
}(React_1.BaseViewModel));
exports.AppViewModel = AppViewModel;
//# sourceMappingURL=AppViewModel.js.map