Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var rxjs_1 = require("rxjs");
// the offset is needed to prevent the guide from interfering with mouse clicks
exports.BootstrapGuideOffset = 5;
var BootstrapGuide = /** @class */ (function (_super) {
    tslib_1.__extends(BootstrapGuide, _super);
    function BootstrapGuide() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mouseMoveSub = rxjs_1.Subscription.EMPTY;
        _this.guideRef = React.createRef();
        _this.hlineRef = React.createRef();
        _this.vlineRef = React.createRef();
        return _this;
    }
    BootstrapGuide.prototype.componentDidMount = function () {
        var _this = this;
        var guide = this.guideRef.current;
        if (guide != null) {
            var hline_1 = this.hlineRef.current;
            var vline_1 = this.vlineRef.current;
            this.mouseMoveSub = rxjs_1.Observable.fromEvent(document, 'mousemove')
                .do(function (e) {
                guide.style.visibility = e.shiftKey === true ? 'visible' : 'hidden';
            })
                .filter(function (e) { return e.shiftKey === true; })
                .subscribe(function (e) {
                guide.style.top = _this.calculateTop(guide, e) + "px";
                if (hline_1 != null) {
                    hline_1.style.top = Math.max(0, e.pageY - exports.BootstrapGuideOffset) + "px";
                }
                if (vline_1 != null) {
                    vline_1.style.left = Math.max(0, e.pageX - exports.BootstrapGuideOffset) + "px";
                }
            });
        }
    };
    BootstrapGuide.prototype.componentWillUnmount = function () {
        this.mouseMoveSub = rxjs_1.Subscription.unsubscribe(this.mouseMoveSub);
    };
    BootstrapGuide.prototype.render = function () {
        return (React.createElement("div", { ref: this.guideRef, className: "BootstrapGuide" },
            React.createElement(react_bootstrap_1.Grid, null,
                React.createElement(react_bootstrap_1.Row, null, ix_1.Iterable.range(1, 12)
                    .map(function (x) { return (React.createElement(react_bootstrap_1.Col, { key: x, className: "BootstrapGuide-col", xs: 1 },
                    React.createElement("div", { className: "BootstrapGuide-block" }, "Col " + x))); })
                    .toArray())),
            React.createElement("div", { ref: this.hlineRef, className: "BootstrapGuide-line BootstrapGuide-hline" }),
            React.createElement("div", { ref: this.vlineRef, className: "BootstrapGuide-line BootstrapGuide-vline" })));
    };
    BootstrapGuide.prototype.calculateTop = function (guide, e) {
        var parent = guide.offsetParent;
        var offset = parent.offsetTop;
        var maxY = parent.clientHeight - guide.clientHeight;
        return Math.min(maxY, Math.max(0, e.pageY - guide.clientHeight - offset - exports.BootstrapGuideOffset));
    };
    return BootstrapGuide;
}(React.Component));
exports.BootstrapGuide = BootstrapGuide;
//# sourceMappingURL=BootstrapGuide.js.map