/// <reference types="react" />
import * as React from 'react';
import { Button, ButtonProps } from 'react-bootstrap';
import { Command } from '../../../WebRx';
import { TooltipPlacement } from '../ContentTooltip/ContentTooltip';
export interface CommandButtonProps extends Omit<ButtonProps, React.HTMLProps<Button>> {
    id?: string;
    command?: Command | (() => Command);
    commandParameter?: any;
    stopPropagation?: boolean;
    preventDefault?: boolean;
    plain?: boolean;
    compact?: boolean;
    tooltip?: any;
    tooltipPlacement?: TooltipPlacement;
}
export interface CommandButtonComponentProps extends React.HTMLProps<any>, CommandButtonProps {
}
export declare class CommandButton extends React.Component<CommandButtonComponentProps> {
    static displayName: string;
    static defaultProps: Partial<CommandButtonComponentProps>;
    private canExecuteSubscription;
    private getCommand();
    private getParam();
    componentWillMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private renderButton(rest);
    protected getComponentClass(): React.ReactType<any>;
    protected handleClick(e: React.MouseEvent<Button>): void;
}
