/// <reference types="react" />
import * as React from 'react';
import { Panel, PanelProps, TransitionCallbacks } from 'react-bootstrap';
export declare type CommonPannelContent = ((x: CommonPanel) => any) | any;
export declare type CommonPanelSectionFormatter = (section: any) => any;
export declare type CommonPanelContentSection = 'header' | 'body' | 'footer';
export declare type CommonPanelContentType = 'teaser' | 'summary';
export interface CommonPanelActionsProps {
    section?: CommonPanelContentSection;
}
export declare class CommonPanelActions extends React.Component<CommonPanelActionsProps> {
    render(): JSX.Element;
}
export declare type BootstrapPanelProps = Omit2<PanelProps, React.HTMLProps<Panel>, TransitionCallbacks>;
export interface CommonPanelRenderProps extends BootstrapPanelProps {
    headerContent?: CommonPannelContent;
    headerActions?: any;
    headerFormat?: CommonPanelSectionFormatter;
    teaserContent?: CommonPannelContent;
    summaryContent?: CommonPannelContent;
    footerContent?: CommonPannelContent;
    footerActions?: any;
    footerFormat?: CommonPanelSectionFormatter;
    shadow?: boolean;
}
export interface CommonPanelProps extends PanelProps, CommonPanelRenderProps {
}
export declare class CommonPanel extends React.Component<CommonPanelProps> {
    static displayName: string;
    static Actions: typeof CommonPanelActions;
    static defaultProps: Partial<CommonPanelProps>;
    render(): JSX.Element;
    private renderContent(content, section, sectionType?);
    private renderActions(actions, section);
    private renderHeaderFooter(content, actions, section, formatter?);
}
