// tslint:disable:max-classes-per-file
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var CommandButton_1 = require("../CommandButton/CommandButton");
var CommonPanelActions = /** @class */ (function (_super) {
    tslib_1.__extends(CommonPanelActions, _super);
    function CommonPanelActions() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CommonPanelActions.prototype.render = function () {
        return (React.createElement(react_bootstrap_1.ButtonToolbar, { className: "CommonPanel-" + this.props.section + "Actions" }, this.props.children));
    };
    return CommonPanelActions;
}(React.Component));
exports.CommonPanelActions = CommonPanelActions;
var CommonPanel = /** @class */ (function (_super) {
    tslib_1.__extends(CommonPanel, _super);
    function CommonPanel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CommonPanel.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var headerContent = x.headerContent, headerActions = x.headerActions, headerFormat = x.headerFormat, teaserContent = x.teaserContent, summaryContent = x.summaryContent, footerContent = x.footerContent, footerActions = x.footerActions, footerFormat = x.footerFormat, shadow = x.shadow;
            return {
                headerContent: headerContent,
                headerActions: headerActions,
                headerFormat: headerFormat,
                teaserContent: teaserContent,
                summaryContent: summaryContent,
                footerContent: footerContent,
                footerActions: footerActions,
                footerFormat: footerFormat,
                shadow: shadow,
            };
        }), className = _a.className, children = _a.children, props = _a.props, rest = _a.rest;
        var panelClassName = this.wxr.classNames('CommonPanel', {
            shadow: props.shadow === true,
            collapsible: rest.collapsible,
        }, className);
        return (React.createElement(react_bootstrap_1.Panel, tslib_1.__assign({}, rest, { className: panelClassName, header: rest.header ||
                this.renderHeaderFooter(props.headerContent, props.headerActions, 'header', props.headerFormat), footer: rest.footer ||
                this.renderHeaderFooter(props.footerContent, props.footerActions, 'footer', props.footerFormat) }),
            this.renderContent(props.teaserContent, 'body', 'teaser'),
            children,
            this.renderContent(props.summaryContent, 'body', 'summary')));
    };
    CommonPanel.prototype.renderContent = function (content, section, sectionType) {
        return (content && (React.createElement("div", { className: this.wxr.classNames("CommonPanel-" + section + "Content", sectionType == null ? null : "CommonPanel-" + sectionType) }, content instanceof Function ? content(this) : content)));
    };
    CommonPanel.prototype.renderActions = function (actions, section) {
        if (React.isValidElement(actions)) {
            if (actions.type === CommonPanelActions) {
                return React.cloneElement(actions, { section: section });
            }
            return actions;
        }
        if (actions instanceof Function) {
            return actions(this);
        }
        return (React.createElement(CommonPanelActions, { section: section }, Array.isArray(actions) ? (actions.map(function (x, i) { return React.createElement(CommandButton_1.CommandButton, tslib_1.__assign({ key: x.id || i }, x)); })) : (React.createElement(CommandButton_1.CommandButton, tslib_1.__assign({}, actions)))));
    };
    CommonPanel.prototype.renderHeaderFooter = function (content, actions, section, formatter) {
        var _this = this;
        if (formatter === void 0) { formatter = function (x) { return x; }; }
        return this.wxr.renderConditional(content != null || actions != null, function () {
            return formatter(React.createElement("div", { className: "CommonPanel-" + section },
                content && _this.renderContent(content, section),
                actions && _this.renderActions(actions, section)));
        });
    };
    CommonPanel.displayName = 'CommonPanel';
    CommonPanel.Actions = CommonPanelActions;
    CommonPanel.defaultProps = {
        defaultExpanded: true,
    };
    return CommonPanel;
}(React.Component));
exports.CommonPanel = CommonPanel;
//# sourceMappingURL=CommonPanel.js.map