import { ObservableLike, ObservableOrValue } from '../../../WebRx';
import { PagerViewModel } from '../Pager/PagerViewModel';
import { DataGridViewModel, DataSourceRequest, DataSourceResponse } from './DataGridViewModel';
export declare type DataSourceResponseSelector<T, TContext> = (request?: DataSourceRequest<TContext>) => ObservableOrValue<DataSourceResponse<T> | undefined>;
export declare class AsyncDataGridViewModel<T, TRequestContext = any> extends DataGridViewModel<T, TRequestContext> {
    protected readonly responseSelector: DataSourceResponseSelector<T, TRequestContext>;
    static displayName: string;
    static DefaultRateLimit: number;
    /**
     * @param responseSelector delegate that produces a response from a request.
     * @param pager pager. if omitted a default pager will be created. use null for no pager.
     * @param context request context included in projection requests. if included requests are bound to context events.
     */
    constructor(responseSelector: DataSourceResponseSelector<T, TRequestContext>, pager?: PagerViewModel, context?: ObservableLike<TRequestContext>, rateLimit?: number);
    getResponse(request: DataSourceRequest | undefined): ObservableOrValue<DataSourceResponse<T> | undefined>;
}
