Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var DataGridViewModel_1 = require("./DataGridViewModel");
var AsyncDataGridViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(AsyncDataGridViewModel, _super);
    /**
     * @param responseSelector delegate that produces a response from a request.
     * @param pager pager. if omitted a default pager will be created. use null for no pager.
     * @param context request context included in projection requests. if included requests are bound to context events.
     */
    function AsyncDataGridViewModel(responseSelector, pager, context, rateLimit) {
        if (rateLimit === void 0) { rateLimit = AsyncDataGridViewModel.DefaultRateLimit; }
        var _this = _super.call(this, ix_1.Iterable.empty(), pager, context, undefined, rateLimit) || this;
        _this.responseSelector = responseSelector;
        return _this;
    }
    AsyncDataGridViewModel.prototype.getResponse = function (request) {
        return this.responseSelector(request);
    };
    AsyncDataGridViewModel.displayName = 'AsyncDataGridViewModel';
    AsyncDataGridViewModel.DefaultRateLimit = 250;
    return AsyncDataGridViewModel;
}(DataGridViewModel_1.DataGridViewModel));
exports.AsyncDataGridViewModel = AsyncDataGridViewModel;
//# sourceMappingURL=AsyncDataGridViewModel.js.map