/// <reference types="react" />
import * as React from 'react';
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { GridViewColumns } from '../ListItems/GridViewColumn';
import { ListItemsProps } from '../ListItems/ListItemsView';
import { PagerProps } from '../Pager/PagerView';
import { PanelFragment, PanelItemContext } from '../Panel/Panel';
import { DataGridViewModel, DataSourceRequest } from './DataGridViewModel';
export interface DataGridProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends ListItemsProps<T, TContext> {
    pager?: boolean | PagerProps | {};
    loadingContent?: React.ReactNode | (() => React.ReactNode);
}
export interface DataGridViewProps extends BaseViewProps<DataGridViewModel<{}>>, DataGridProps {
    fill?: boolean;
}
export declare class DataGridView extends BaseView<DataGridViewProps, DataGridViewModel<{}>> {
    static displayName: string;
    static readonly Columns: typeof GridViewColumns;
    static defaultProps: Partial<DataGridProps>;
    constructor(props: any);
    updateOn(viewModel: Readonly<DataGridViewModel<{}>>): Observable<boolean>[];
    render(): JSX.Element;
    protected renderDefaultDataGridView(props: DataGridProps): JSX.Element;
    protected renderHeader(fragment: PanelFragment, item: {} | undefined, field: string | undefined): {} | null | undefined;
    protected renderSortIcon(field: string | undefined, request: DataSourceRequest | undefined): JSX.Element | null;
    protected getSortIconName(field: string | undefined, request: DataSourceRequest | undefined): "sort-asc" | "sort-desc" | undefined;
}
