Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_fa_1 = require("react-fa");
var Compare_1 = require("../../../Utils/Compare");
var React_1 = require("../../React");
var CommandButton_1 = require("../CommandButton/CommandButton");
var GridView_1 = require("../ListItems/GridView");
var GridViewColumn_1 = require("../ListItems/GridViewColumn");
var ListItemsView_1 = require("../ListItems/ListItemsView");
var Loading_1 = require("../Loading/Loading");
var PagerView_1 = require("../Pager/PagerView");
var DataGridView = /** @class */ (function (_super) {
    tslib_1.__extends(DataGridView, _super);
    function DataGridView(props) {
        var _this = _super.call(this, props) || this;
        _this.renderHeader = _this.renderHeader.bind(_this);
        return _this;
    }
    DataGridView.prototype.updateOn = function (viewModel) {
        return [viewModel.isLoading.changed];
    };
    DataGridView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var pager = x.pager, loadingContent = x.loadingContent, fill = x.fill, view = x.view, viewProps = x.viewProps, viewTemplate = x.viewTemplate, itemsPanelTemplate = x.itemsPanelTemplate, itemTemplate = x.itemTemplate, itemClassName = x.itemClassName, itemStyle = x.itemStyle, itemProps = x.itemProps, compact = x.compact, emptyContent = x.emptyContent;
            return {
                pager: pager,
                loadingContent: loadingContent,
                fill: fill,
                view: view,
                viewProps: viewProps,
                viewTemplate: viewTemplate,
                itemsPanelTemplate: itemsPanelTemplate,
                itemTemplate: itemTemplate,
                itemClassName: itemClassName,
                itemStyle: itemStyle,
                itemProps: itemProps,
                compact: compact,
                emptyContent: emptyContent,
            };
        }), className = _a.className, children = _a.children, props = _a.props, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('DataGrid', className) }), Loading_1.Loading.renderLoadable(this.viewModel.isLoading, props.loadingContent, function () {
            var dataGridView = ListItemsView_1.ListItemsView.getListItemsView(_this.props, _this.renderDefaultDataGridView.bind(_this));
            var pagerView = props.pager &&
                _this.viewModel.pager &&
                (React.isValidElement(props.pager) ? (props.pager) : (React.createElement(PagerView_1.PagerView, tslib_1.__assign({ viewModel: _this.viewModel.pager }, (props.pager === true ? {} : props.pager)))));
            return (React.createElement("div", { className: "DataGrid-container" },
                React.createElement(ListItemsView_1.ListItemsView, { viewModel: _this.viewModel, view: dataGridView, viewProps: props.viewProps, viewTemplate: props.viewTemplate, itemsPanelTemplate: props.itemsPanelTemplate, itemTemplate: props.itemTemplate, itemClassName: props.itemClassName, itemStyle: props.itemStyle, itemProps: props.itemProps, compact: props.compact, emptyContent: props.emptyContent }),
                pagerView));
        })));
    };
    DataGridView.prototype.renderDefaultDataGridView = function (props) {
        return (React.createElement(GridView_1.GridView, { headerTemplate: this.renderHeader }, props.children));
    };
    DataGridView.prototype.renderHeader = function (fragment, item, field) {
        if (field == null) {
            return fragment;
        }
        return (React.createElement(CommandButton_1.CommandButton, { className: "DataGrid-header", block: true, bsStyle: "link", command: this.viewModel.toggleSortDirection, commandParameter: field },
            fragment,
            this.renderSortIcon(field, this.viewModel.requests.value)));
    };
    DataGridView.prototype.renderSortIcon = function (field, request) {
        var iconName = this.getSortIconName(field, request);
        if (String.isNullOrEmpty(iconName)) {
            return null;
        }
        return React.createElement(react_fa_1.Icon, { name: iconName, size: "lg" });
    };
    DataGridView.prototype.getSortIconName = function (field, request) {
        if (request == null ||
            request.sort == null ||
            request.sort.field == null ||
            request.sort.direction == null ||
            request.sort.field !== field) {
            return undefined;
        }
        if (request.sort.direction === Compare_1.SortDirection.Ascending) {
            return 'sort-asc';
        }
        else if (request.sort.direction === Compare_1.SortDirection.Descending) {
            return 'sort-desc';
        }
        return undefined;
    };
    DataGridView.displayName = 'DataGridView';
    DataGridView.Columns = GridViewColumn_1.GridViewColumns;
    DataGridView.defaultProps = {
        loadingContent: 'Loading Data...',
    };
    return DataGridView;
}(React_1.BaseView));
exports.DataGridView = DataGridView;
//# sourceMappingURL=DataGridView.js.map