import { Sizes } from 'react-bootstrap';
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { BindableProps } from '../BindableInput/BindableInput';
import { TooltipPlacement } from '../ContentTooltip/ContentTooltip';
import { InlineEditViewModel } from './InlineEditViewModel';
export interface InlineEditProps extends BindableProps {
    controlId?: string;
    inputType?: string;
    placeholder?: string;
    keyboard?: boolean;
    clickToEdit?: boolean;
    bsSize?: Sizes;
    template?: (value: any, view: InlineEditView) => any;
    editTemplate?: (value: any, view: InlineEditView) => any;
    errorContent?: any | ((viewModel: Readonly<InlineEditViewModel<{}>>, view: InlineEditView) => any);
    errorPlacement?: TooltipPlacement;
}
export interface InlineEditViewProps extends BaseViewProps<InlineEditViewModel<{}>>, InlineEditProps {
}
export declare class InlineEditView extends BaseView<InlineEditViewProps, InlineEditViewModel<{}>> {
    static displayName: string;
    static defaultProps: Partial<InlineEditProps>;
    private handleKeyDown(e);
    private focusAndSelectControlText(instance);
    updateOn(viewModel: Readonly<InlineEditViewModel<{}>>): Observable<boolean>[];
    render(): {} | null | undefined;
    private renderErrorTooltip();
    private renderEditor();
    private renderBindableInput();
    private renderValue();
}
