import { Observable } from 'rxjs';
import { Command, Property, ReadOnlyProperty } from '../../../WebRx';
import { BaseViewModel } from '../../React';
export declare class InlineEditViewModel<T> extends BaseViewModel {
    protected readonly onSave: (value: T, viewModel: InlineEditViewModel<T>) => T | Observable<T>;
    static displayName: string;
    readonly value: Property<T>;
    readonly editValue: Property<T | undefined>;
    readonly isEditing: ReadOnlyProperty<boolean>;
    readonly hasSavingError: ReadOnlyProperty<boolean>;
    readonly edit: Command<T>;
    readonly save: Command<T>;
    readonly cancel: Command<undefined>;
    readonly setError: Command<boolean>;
    constructor(value?: Property<T> | T, onSave?: (value: T, viewModel: InlineEditViewModel<T>) => T | Observable<T>);
}
