Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var clone = require("clone");
var rxjs_1 = require("rxjs");
var React_1 = require("../../React");
var InlineEditViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(InlineEditViewModel, _super);
    function InlineEditViewModel(value, onSave) {
        if (onSave === void 0) { onSave = function (x) { return x; }; }
        var _this = _super.call(this) || this;
        _this.onSave = onSave;
        if (_this.wx.isProperty(value)) {
            _this.value = value;
        }
        else {
            _this.value = _this.wx.property(value);
        }
        _this.editValue = _this.wx.property();
        _this.edit = _this.wx.command(function () {
            return clone(_this.value.value);
        });
        _this.save = _this.wx.command(function () {
            return rxjs_1.Observable.defer(function () {
                return _this.wx.asObservable(_this.onSave(_this.editValue.value, _this));
            }).do({
                error: function (e) {
                    _this.alertForError(e, 'Unable to Save');
                },
            });
        });
        _this.cancel = _this.wx.command(
        // prevent cancel from being executed while we are waiting for save to respond
        _this.save.isExecutingObservable.map(function (x) { return x === false; }), 
        // this is intentionally returning undefined to 'reset' the editValue
        function () { return undefined; });
        _this.setError = _this.wx.command();
        _this.addSubscription(rxjs_1.Observable.merge(_this.edit.results, _this.save.results.map(function (x) { return undefined; }), _this.cancel.results).subscribe(function (x) {
            _this.editValue.value = x;
        }));
        _this.isEditing = rxjs_1.Observable.merge(_this.edit.results.map(function () { return true; }), _this.save.results.map(function () { return false; }), _this.cancel.results.map(function () { return false; })).toProperty(false);
        _this.hasSavingError = rxjs_1.Observable.merge(_this.save.results.map(function () { return false; }), _this.save.thrownErrors.map(function () { return true; }), _this.cancel.results.map(function () { return false; }))
            .startWith(false)
            .combineLatest(_this.setError.results.startWith(false), function (hasError, hasManualError) { return hasManualError || hasError; })
            .toProperty(false);
        _this.addSubscription(_this.save.results.subscribe(function (x) {
            _this.value.value = x;
        }));
        return _this;
    }
    InlineEditViewModel.displayName = 'InlineEditViewModel';
    return InlineEditViewModel;
}(React_1.BaseViewModel));
exports.InlineEditViewModel = InlineEditViewModel;
//# sourceMappingURL=InlineEditViewModel.js.map