Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var AsyncDataGridViewModel_1 = require("../DataGrid/AsyncDataGridViewModel");
var ItemListPanelViewModel_1 = require("./ItemListPanelViewModel");
var AsyncItemListPanelViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(AsyncItemListPanelViewModel, _super);
    /**
     * @param responseSelector delegate that produces a response from a request.
     * @param filterer filter predicate. executed for each item when the search context is available.
     * @param search search handler. if omitted a default search handler will be created. use null for no search handling.
     * @param pager pager. if omitted a default pager will be created. use null for no pager.
     * @param context request context included in projection requests. if included requests are bound to context events.
     */
    function AsyncItemListPanelViewModel(responseSelector, search, pager, context, rateLimit) {
        if (rateLimit === void 0) { rateLimit = AsyncDataGridViewModel_1.AsyncDataGridViewModel.DefaultRateLimit; }
        var _this = _super.call(this, ix_1.Iterable.empty(), undefined, search, pager, context, undefined, rateLimit) || this;
        _this.responseSelector = responseSelector;
        return _this;
    }
    AsyncItemListPanelViewModel.prototype.getResponse = function (request) {
        return this.responseSelector(request);
    };
    AsyncItemListPanelViewModel.displayName = 'AsyncItemListPanelViewModel';
    return AsyncItemListPanelViewModel;
}(ItemListPanelViewModel_1.ItemListPanelViewModel));
exports.AsyncItemListPanelViewModel = AsyncItemListPanelViewModel;
//# sourceMappingURL=AsyncItemListPanelViewModel.js.map