Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var AsyncDataGridViewModel_1 = require("../DataGrid/AsyncDataGridViewModel");
var TreeItemListPanelViewModel_1 = require("./TreeItemListPanelViewModel");
var AsyncTreeItemListPanelViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(AsyncTreeItemListPanelViewModel, _super);
    /**
     * @param responseSelector delegate that produces a response from a request.
     * @param itemsSource delegate to produce sub-items from a source item.
     * @param search search handler. if omitted a default search handler will be created. use null for no search handling.
     * @param context request context included in projection requests. if included requests are bound to context events.
     */
    function AsyncTreeItemListPanelViewModel(responseSelector, itemsSource, search, context, rateLimit) {
        if (rateLimit === void 0) { rateLimit = AsyncDataGridViewModel_1.AsyncDataGridViewModel.DefaultRateLimit; }
        var _this = _super.call(this, ix_1.Iterable.empty(), itemsSource, function (x) { return x; }, undefined, search, context, rateLimit) || this;
        _this.responseSelector = responseSelector;
        return _this;
    }
    AsyncTreeItemListPanelViewModel.prototype.getResponse = function (request) {
        return this.responseSelector(request);
    };
    AsyncTreeItemListPanelViewModel.displayName = 'AsyncTreeItemListPanelViewModel';
    return AsyncTreeItemListPanelViewModel;
}(TreeItemListPanelViewModel_1.TreeItemListPanelViewModel));
exports.AsyncTreeItemListPanelViewModel = AsyncTreeItemListPanelViewModel;
//# sourceMappingURL=AsyncTreeItemListPanelViewModel.js.map