Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var rxjs_1 = require("rxjs");
var CountFooterContent = /** @class */ (function (_super) {
    tslib_1.__extends(CountFooterContent, _super);
    function CountFooterContent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.countChangedSub = rxjs_1.Subscription.EMPTY;
        return _this;
    }
    CountFooterContent.prototype.componentDidMount = function () {
        this.subscribeToCount(this.props.count);
    };
    CountFooterContent.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.count !== this.props.count) {
            this.subscribeToCount(this.props.count);
        }
    };
    CountFooterContent.prototype.componentWillUnmount = function () {
        this.unsubscribeFromCount();
    };
    CountFooterContent.prototype.render = function () {
        var _this = this;
        var count = this.state == null ? 0 : this.state.count || 0;
        return (React.createElement("div", { className: "CountFooterContent" },
            React.createElement(react_bootstrap_1.Badge, null, count),
            this.wxr.renderConditional(String.isNullOrEmpty(this.props.suffix) === false, function () { return (React.createElement("span", { className: "CountFooterContent-suffix" }, _this.props.suffix)); })));
    };
    CountFooterContent.prototype.unsubscribeFromCount = function () {
        this.countChangedSub = rxjs_1.Subscription.unsubscribe(this.countChangedSub);
    };
    CountFooterContent.prototype.subscribeToCount = function (count) {
        var _this = this;
        this.unsubscribeFromCount();
        this.countChangedSub = this.wx.whenAny(count, function (x) { return x; }).subscribe(function (x) {
            _this.setState(function (prevState, props) {
                return {
                    count: x || 0,
                };
            });
        });
    };
    CountFooterContent.displayName = 'CountFooterContent';
    return CountFooterContent;
}(React.Component));
exports.CountFooterContent = CountFooterContent;
//# sourceMappingURL=CountFooterContent.js.map