/// <reference types="react" />
import * as React from 'react';
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { CommonPanelRenderProps } from '../CommonPanel/CommonPanel';
import { DataGridProps } from '../DataGrid/DataGridView';
import { PanelItemContext } from '../Panel/Panel';
import { SearchProps } from '../Search/SearchView';
import { ItemListPanelViewModel } from './ItemListPanelViewModel';
export interface ItemListPanelProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends DataGridProps<T, TContext>, CommonPanelRenderProps {
    search?: boolean | SearchProps | {};
}
export interface ItemListPanelViewProps extends BaseViewProps<ItemListPanelViewModel<{}>>, ItemListPanelProps {
}
export declare class ItemListPanelView extends BaseView<ItemListPanelViewProps, ItemListPanelViewModel<{}>> {
    static displayName: string;
    static defaultProps: Partial<ItemListPanelProps>;
    constructor(props: any);
    updateOn(viewModel: Readonly<ItemListPanelViewModel<{}>>): Observable<boolean>[];
    render(): JSX.Element;
    protected renderPanelHeader(content: any, searchView: any): JSX.Element;
    protected renderDataGrid(props: ItemListPanelProps): JSX.Element;
    protected handleSearchClick(e: React.MouseEvent<any>): void;
}
