Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var React_1 = require("../../React");
var CommonPanel_1 = require("../CommonPanel/CommonPanel");
var DataGridView_1 = require("../DataGrid/DataGridView");
var SearchView_1 = require("../Search/SearchView");
var ItemListPanelView = /** @class */ (function (_super) {
    tslib_1.__extends(ItemListPanelView, _super);
    function ItemListPanelView(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSearchClick = _this.handleSearchClick.bind(_this);
        return _this;
    }
    ItemListPanelView.prototype.updateOn = function (viewModel) {
        return [viewModel.isLoading.changed];
    };
    ItemListPanelView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var search = x.search, pager = x.pager, loadingContent = x.loadingContent, view = x.view, viewProps = x.viewProps, viewTemplate = x.viewTemplate, itemsPanelTemplate = x.itemsPanelTemplate, itemTemplate = x.itemTemplate, itemClassName = x.itemClassName, itemStyle = x.itemStyle, itemProps = x.itemProps, compact = x.compact, emptyContent = x.emptyContent;
            return {
                search: search,
                pager: pager,
                loadingContent: loadingContent,
                view: view,
                viewProps: viewProps,
                viewTemplate: viewTemplate,
                itemsPanelTemplate: itemsPanelTemplate,
                itemTemplate: itemTemplate,
                itemClassName: itemClassName,
                itemStyle: itemStyle,
                itemProps: itemProps,
                compact: compact,
                emptyContent: emptyContent,
            };
        }), className = _a.className, children = _a.children, props = _a.props, rest = _a.rest;
        var searchView = props.search &&
            this.viewModel.search &&
            (React.isValidElement(props.search) ? (props.search) : (React.createElement(SearchView_1.SearchView, tslib_1.__assign({ viewModel: this.viewModel.search, disabled: this.viewModel.isLoading.value, onClick: this.handleSearchClick }, (props.search === true ? {} : props.search)))));
        var headerFormat = this.props.headerFormat == null && searchView != null
            ? function (content) { return _this.renderPanelHeader(content, searchView); }
            : undefined;
        return (React.createElement(CommonPanel_1.CommonPanel, tslib_1.__assign({ headerFormat: headerFormat }, this.trimProps(rest), { className: this.wxr.classNames('ItemListPanel', className) }), this.renderDataGrid(props)));
    };
    ItemListPanelView.prototype.renderPanelHeader = function (content, searchView) {
        return (React.createElement("div", null,
            content,
            searchView));
    };
    ItemListPanelView.prototype.renderDataGrid = function (props) {
        var search = props.search, dataGridProps = tslib_1.__rest(props, ["search"]);
        return (React.createElement(DataGridView_1.DataGridView, tslib_1.__assign({}, dataGridProps, { viewModel: this.viewModel, fill: true }), this.props.children));
    };
    ItemListPanelView.prototype.handleSearchClick = function (e) {
        e.stopPropagation();
    };
    ItemListPanelView.displayName = 'ItemListPanelView';
    ItemListPanelView.defaultProps = {};
    return ItemListPanelView;
}(React_1.BaseView));
exports.ItemListPanelView = ItemListPanelView;
//# sourceMappingURL=ItemListPanelView.js.map