/// <reference types="react" />
import { Iterable } from 'ix';
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { PanelItemContext, PanelItemProps, PanelRenderProps } from '../Panel';
import { ItemsPresenterTemplateProps } from './ItemsPresenter';
import { ItemsViewModel } from './ItemsViewModel';
export interface ItemsProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends ItemsPresenterTemplateProps<T>, PanelItemProps<T, TContext>, PanelRenderProps {
}
export interface ItemsViewProps extends BaseViewProps<ItemsViewModel<{}>>, ItemsProps {
    fill?: boolean;
}
export declare class ItemsView extends BaseView<ItemsViewProps, ItemsViewModel<{}>> {
    static displayName: string;
    updateOn(viewModel: Readonly<ItemsViewModel<{}>>): Observable<Iterable<{}> | ArrayLike<{}>>[];
    render(): JSX.Element;
}
