Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var React_1 = require("../../React");
var ItemsViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(ItemsViewModel, _super);
    function ItemsViewModel(source) {
        var _this = _super.call(this) || this;
        _this.emptySource = ix_1.Iterable.empty();
        _this.source = _this.wx
            .getObservableOrAlert(function () {
            return _this.wx.getObservable(source).map(function (x) { return ix_1.Iterable.from(x); });
        }, 'Invalid Items Source')
            .toProperty(_this.emptySource, false);
        _this.count = _this.wx
            .whenAny(_this.source, function (x) { return ix_1.Iterable.from(x || []).count(); })
            .toProperty();
        return _this;
    }
    ItemsViewModel.prototype.getItemsSourceProperty = function () {
        return this.source;
    };
    ItemsViewModel.prototype.getItemsSource = function () {
        return this.getItemsSourceProperty().value;
    };
    ItemsViewModel.prototype.getItems = function () {
        return ix_1.Iterable.from(this.getItemsSource());
    };
    ItemsViewModel.prototype.getItemAt = function (index) {
        return this.getItems().elementAt(index);
    };
    ItemsViewModel.displayName = 'ItemsViewModel';
    return ItemsViewModel;
}(React_1.BaseViewModel));
exports.ItemsViewModel = ItemsViewModel;
//# sourceMappingURL=ItemsViewModel.js.map