/// <reference types="react" />
import * as React from 'react';
import { ItemsPresenter } from '../Items/ItemsPresenter';
import { PanelFragment, PanelItemContext } from '../Panel/Panel';
import { BootstrapTableProps } from '../Panel/TablePanel';
import { GridViewColumns } from './GridViewColumn';
import { ListItemsViewTemplate, ListItemsViewTemplateProps } from './ListItemsViewTemplate';
export interface GridTemplateProps<T = {}> {
    headerTemplate?: (header: PanelFragment, item: T | undefined, field: string | undefined) => PanelFragment;
    cellTemplate?: (cell: PanelFragment, item: T | undefined, field: string | undefined) => PanelFragment;
}
export interface GridTableRenderProps extends BootstrapTableProps {
    fixedLayout?: boolean;
}
export interface GridViewProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends GridTemplateProps<T>, ListItemsViewTemplateProps<T, TContext>, GridTableRenderProps {
}
export interface GridViewComponentProps extends React.HTMLProps<any>, GridViewProps {
}
export declare class GridView extends ListItemsViewTemplate<GridViewProps> {
    static displayName: string;
    static readonly Columns: typeof GridViewColumns;
    private readonly logger;
    private columns;
    constructor(props: any);
    render(): JSX.Element | null;
    protected renderTablePanel(itemTemplates: React.ReactNode[], itemsPresenter: ItemsPresenter, items: Array<{}> | undefined): JSX.Element;
    protected getColumnDefinitions(): React.ReactChild[] | undefined;
    protected renderTableHeaderRow(): JSX.Element | undefined;
    protected renderTableRow(item: {}, index: number): JSX.Element | undefined;
}
