/// <reference types="react" />
import * as React from 'react';
import { BaseView, BaseViewProps } from '../../React';
import { ItemsProps } from '../Items/ItemsView';
import { PanelItemContext } from '../Panel/Panel';
import { ListItemsViewModel } from './ListItemsViewModel';
import { ListItemsViewTemplateProps } from './ListItemsViewTemplate';
export interface ListItemsProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends ItemsProps<T, TContext> {
    view?: React.ReactElement<ListItemsViewTemplateProps<T, TContext>>;
    viewProps?: {};
    children?: React.ReactNode;
}
export interface ListItemsViewProps extends BaseViewProps<ListItemsViewModel<{}>>, ListItemsProps {
    fill?: boolean;
}
export declare class ListItemsView extends BaseView<ListItemsViewProps, ListItemsViewModel<{}>> {
    static renderDefaultListItemsView(): JSX.Element;
    static getListItemsView<T extends ListItemsProps>(props: T, defaultListItemsView: (props: T) => React.ReactElement<ListItemsViewTemplateProps>): React.ReactElement<ListItemsViewTemplateProps>;
    render(): React.ReactElement<ListItemsViewTemplateProps<{}, PanelItemContext>>;
}
