Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var classNames = require("classnames");
var React = require("react");
var React_1 = require("../../React");
var GridViewColumn_1 = require("./GridViewColumn");
var ListGroupView_1 = require("./ListGroupView");
var ListItemsView = /** @class */ (function (_super) {
    tslib_1.__extends(ListItemsView, _super);
    function ListItemsView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ListItemsView.renderDefaultListItemsView = function () {
        return React.createElement(ListGroupView_1.ListGroupView, null);
    };
    ListItemsView.getListItemsView = function (props, defaultListItemsView) {
        if (props.view != null) {
            return props.view;
        }
        if (React.Children.count(props.children) === 1) {
            var view = React.Children.only(props.children);
            if (!React.isType(view, GridViewColumn_1.GridViewColumns)) {
                return view;
            }
        }
        return defaultListItemsView(props);
    };
    ListItemsView.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var view = x.view, viewProps = x.viewProps;
            return { view: view, viewProps: viewProps };
        }), className = _a.className, children = _a.children, props = _a.props, rest = _a.rest;
        var listItemsView = ListItemsView.getListItemsView(this.props, ListItemsView.renderDefaultListItemsView);
        var listItemsViewProps = tslib_1.__assign({ itemsProps: this.trimProps(Object.assign({}, listItemsView.props.itemsProps, rest)), listItems: this.viewModel, className: classNames('ListItems', className, listItemsView.props.className) }, this.trimProps(props.viewProps || {}));
        return React.cloneElement(listItemsView, listItemsViewProps);
    };
    return ListItemsView;
}(React_1.BaseView));
exports.ListItemsView = ListItemsView;
//# sourceMappingURL=ListItemsView.js.map