import { Command, IterableLike, ObservableLike, ReadOnlyProperty } from '../../../WebRx';
import { ItemsViewModel } from '../Items/ItemsViewModel';
export declare class ListItemsViewModel<T> extends ItemsViewModel<T> {
    static displayName: string;
    readonly selectedItem: ReadOnlyProperty<T>;
    readonly selectedItems: ReadOnlyProperty<T[]>;
    readonly selectedIndex: ReadOnlyProperty<number>;
    readonly selectedIndicies: ReadOnlyProperty<number[]>;
    readonly selectItem: Command<T>;
    readonly selectItems: Command<T[]>;
    readonly selectIndex: Command<number>;
    readonly selectIndicies: Command<number[]>;
    readonly selectRange: Command<{
        from: T;
        to: T;
    }>;
    constructor(source: ObservableLike<IterableLike<T>>);
    protected getItemsForIndicies(indicies: IterableLike<number>): T[] | undefined;
    protected getIndiciesForItems(items: IterableLike<T>): number[] | undefined;
}
