Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var rxjs_1 = require("rxjs");
var ItemsViewModel_1 = require("../Items/ItemsViewModel");
var ListItemsViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(ListItemsViewModel, _super);
    function ListItemsViewModel(source) {
        var _this = _super.call(this, source) || this;
        _this.selectItem = _this.wx.command();
        _this.selectItems = _this.wx.command();
        _this.selectIndex = _this.wx.command();
        _this.selectIndicies = _this.wx.command();
        _this.selectRange = _this.wx.command();
        _this.selectedItems = rxjs_1.Observable.merge(_this.selectItem.results.map(function (x) { return [x]; }), _this.selectItems.results)
            .map(function (x) { return x.filterNull(); })
            .toProperty([], function (a, b) {
            return ix_1.Iterable.from(a).sequenceEqual(ix_1.Iterable.from(b));
        });
        _this.selectedIndicies = rxjs_1.Observable.merge(_this.selectIndex.results.map(function (x) { return [x]; }), _this.selectIndicies.results)
            .map(function (x) { return x.filterNull(); })
            .toProperty([], function (a, b) {
            return ix_1.Iterable.from(a).sequenceEqual(ix_1.Iterable.from(b));
        });
        _this.selectedItem = _this.wx
            .whenAny(_this.selectedItems, function (x) { return x[0]; })
            .toProperty();
        _this.selectedIndex = _this.wx
            .whenAny(_this.selectedIndicies, function (x) { return x[0]; })
            .toProperty();
        _this.addSubscription(_this.wx
            .whenAny(_this.selectRange, function (x) { return x; })
            .map(function (range) {
            if (range.from == null || range.to == null) {
                return [];
            }
            if (range.from === range.to) {
                return [range.from];
            }
            var leftBound = _this.getItems().skipWhile(function (x) { return x !== range.from && x !== range.to; });
            var initial = leftBound.first();
            if (initial == null) {
                return [];
            }
            var end = initial === range.from ? range.to : range.from;
            return leftBound
                .reverse()
                .skipWhile(function (x) { return x !== end; })
                .reverse()
                .toArray();
        })
            .invokeCommand(_this.selectItems));
        _this.addSubscription(_this.wx
            .whenAny(_this.selectedIndicies, function (x) { return x; })
            .map(function (x) {
            return _this.getItemsForIndicies(x);
        })
            .filterNull()
            .invokeCommand(_this.selectItems));
        _this.addSubscription(_this.wx
            .whenAny(_this.selectedItems, function (x) { return x; })
            .map(function (x) {
            return _this.getIndiciesForItems(x);
        })
            .filterNull()
            .invokeCommand(_this.selectIndicies));
        return _this;
    }
    ListItemsViewModel.prototype.getItemsForIndicies = function (indicies) {
        var source = ix_1.Iterable.from(indicies);
        if (source.isEmpty()) {
            return [];
        }
        var set = this.getItems().toArray();
        return source.map(function (x) { return set[x]; }).toArray();
    };
    ListItemsViewModel.prototype.getIndiciesForItems = function (items) {
        var source = ix_1.Iterable.from(items);
        if (source.isEmpty()) {
            return [];
        }
        var set = this.getItems().toArray();
        return ix_1.Iterable.from(items)
            .map(function (x) { return set.indexOf(x); })
            .toArray();
    };
    ListItemsViewModel.displayName = 'ListItemsViewModel';
    return ListItemsViewModel;
}(ItemsViewModel_1.ItemsViewModel));
exports.ListItemsViewModel = ListItemsViewModel;
//# sourceMappingURL=ListItemsViewModel.js.map