/// <reference types="react" />
import * as React from 'react';
import { ItemsProps } from '../Items/ItemsView';
import { PanelItemContext } from '../Panel/Panel';
import { ListItemsViewModel } from './ListItemsViewModel';
import { SelectedPropsFunction } from './SelectableListItem';
export interface ListItemsViewTemplateProps<T = {}, TContext extends PanelItemContext = PanelItemContext> {
    /**
     * internal passthru property
     * DO NOT SET, this property is assigned automatically by the ListItemsView
     */
    listItems?: Readonly<ListItemsViewModel<T>>;
    /**
     * internal passthru property
     * DO NOT SET, this property is assigned automatically by the ListItemsView
     */
    itemsProps?: ItemsProps<T, TContext>;
    /**
     * internal passthru property
     * DO NOT SET, this property is assigned automatically by the ListItemsView
     */
    className?: string;
}
export declare abstract class ListItemsViewTemplate<T extends ListItemsViewTemplateProps> extends React.Component<T> {
    protected getListItems(): Readonly<ListItemsViewModel<{}>>;
    protected getItemsProps(): ItemsProps<{}, PanelItemContext>;
    protected renderListItem(itemTemplate: React.ReactNode, item: {}, selectedProps?: SelectedPropsFunction): JSX.Element;
}
