/// <reference types="react" />
import * as React from 'react';
import { ItemsPanelTemplate, ItemsPresenter } from '../Items/ItemsPresenter';
import { PanelFragment, PanelItemContext } from '../Panel/Panel';
import { ListItemsViewTemplate, ListItemsViewTemplateProps } from './ListItemsViewTemplate';
import { SelectedPropsFunction } from './SelectableListItem';
export interface PanelViewProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends ListItemsViewTemplateProps<T, TContext> {
    itemsPanelTemplate?: ItemsPanelTemplate<T>;
    selectedProps?: SelectedPropsFunction;
}
export interface PanelViewComponentProps extends React.HTMLProps<any>, PanelViewProps {
}
export declare class PanelView extends ListItemsViewTemplate<PanelViewComponentProps> {
    static getSelectedProps(isSelected: boolean, elem: React.ReactElement<React.HTMLProps<any>>): {
        className: string;
    };
    render(): JSX.Element;
    protected getItemsPanelTemplate(panelFragment: PanelFragment, itemTemplates: PanelFragment[], itemsPresenter: ItemsPresenter, items: Array<{}> | undefined): {} | null | undefined;
    protected getItemsPanelTemplateFunction(): (itemTemplates: React.ReactNode[], itemsPresenter: ItemsPresenter, items: {}[] | undefined) => {} | null | undefined;
    protected renderPanelItem(fragment: PanelFragment, context: PanelItemContext, items: Array<{}> | undefined): {} | null | undefined;
}
