Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var classNames = require("classnames");
var React = require("react");
var ItemsView_1 = require("../Items/ItemsView");
var StackPanel_1 = require("../Panel/StackPanel");
var ListItemsViewTemplate_1 = require("./ListItemsViewTemplate");
var PanelView = /** @class */ (function (_super) {
    tslib_1.__extends(PanelView, _super);
    function PanelView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PanelView.getSelectedProps = function (isSelected, elem) {
        return {
            className: classNames({ Selected: isSelected }, elem.props.className),
        };
    };
    PanelView.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var itemsPanelTemplate = x.itemsPanelTemplate, selectedProps = x.selectedProps, listItems = x.listItems, itemsProps = x.itemsProps;
            return { itemsPanelTemplate: itemsPanelTemplate, selectedProps: selectedProps, listItems: listItems, itemsProps: itemsProps };
        }), className = _a.className, rest = _a.rest;
        return (React.createElement(ItemsView_1.ItemsView, tslib_1.__assign({ className: className, viewModel: this.getListItems(), itemsPanelTemplate: this.getItemsPanelTemplateFunction() }, this.getItemsProps(), this.trimProps(rest))));
    };
    PanelView.prototype.getItemsPanelTemplate = function (panelFragment, itemTemplates, itemsPresenter, items) {
        var _this = this;
        if (React.isValidElement(panelFragment)) {
            var itemsPanelTemplateProps = Object.trim({
                itemTemplate: function (fragment, context) {
                    return _this.renderPanelItem(fragment, context, items);
                },
            });
            return React.cloneElement(panelFragment, tslib_1.__assign({}, itemsPanelTemplateProps, panelFragment.props), itemTemplates);
        }
        return panelFragment;
    };
    PanelView.prototype.getItemsPanelTemplateFunction = function () {
        var _this = this;
        var template = this.props.itemsPanelTemplate;
        return function (itemTemplates, itemsPresenter, items) {
            if (template != null) {
                var fragment = template(itemTemplates, itemsPresenter, items);
                return _this.getItemsPanelTemplate(fragment, itemTemplates, itemsPresenter, items);
            }
            if (React.Children.count(_this.props.children) === 1) {
                return _this.getItemsPanelTemplate(React.Children.only(_this.props.children), itemTemplates, itemsPresenter, items);
            }
            return _this.getItemsPanelTemplate(React.createElement(StackPanel_1.StackPanel, null), itemTemplates, itemsPresenter, items);
        };
    };
    PanelView.prototype.renderPanelItem = function (fragment, context, items) {
        if (items == null) {
            return fragment;
        }
        return this.renderListItem(fragment, items[context.index], this.props.selectedProps || PanelView.getSelectedProps);
    };
    return PanelView;
}(ListItemsViewTemplate_1.ListItemsViewTemplate));
exports.PanelView = PanelView;
//# sourceMappingURL=PanelView.js.map