/// <reference types="react" />
import * as React from 'react';
import { ListGroupItemProps } from 'react-bootstrap';
import { ListItemsViewModel } from './ListItemsViewModel';
export declare type SelectedPropsFunction = (isSelected: boolean, elem: React.ReactElement<React.HTMLProps<any>>) => {};
export interface SelectableListItemProps<T = {}> {
    listItems: Readonly<ListItemsViewModel<T>>;
    item: T;
    selectedProps?: SelectedPropsFunction;
}
export declare class SelectableListItem extends React.Component<SelectableListItemProps> {
    static defaultProps: Partial<SelectableListItemProps>;
    private isSelectedSubscription;
    private subscribeToUpdates(listItems);
    private unsubscribeFromUpdates();
    componentDidMount(): void;
    componentWillUpdate(nextProps: Readonly<SelectableListItemProps>): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<any>;
    protected getIsSelected(): boolean;
    protected getListItemProps(elem: React.ReactElement<any>): ListGroupItemProps;
    protected handleClick(e: React.MouseEvent<any>, onClickElement: ((e: React.MouseEvent<any>) => void) | undefined): void;
}
