Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var ListItemsViewModel_1 = require("./ListItemsViewModel");
function flattenItems(item, itemsSource) {
    var items = itemsSource(item);
    return items == null
        ? ix_1.Iterable.of(item)
        : ix_1.Iterable.from(items)
            .flatMap(function (x) { return flattenItems(x, itemsSource); })
            .startWith(item);
}
exports.flattenItems = flattenItems;
var TreeListItemsViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(TreeListItemsViewModel, _super);
    function TreeListItemsViewModel(source, itemsSource) {
        var _this = _super.call(this, source) || this;
        _this.itemsSource = itemsSource;
        return _this;
    }
    TreeListItemsViewModel.prototype.getItems = function () {
        var _this = this;
        return ix_1.Iterable.from(this.getItemsSource()).flatMap(function (x) {
            return _this.flattenItems(x);
        });
    };
    TreeListItemsViewModel.prototype.getItemsForIndicies = function (indicies) {
        return undefined;
    };
    TreeListItemsViewModel.prototype.getIndiciesForItems = function (items) {
        return undefined;
    };
    TreeListItemsViewModel.prototype.flattenItems = function (item) {
        return flattenItems(item, this.itemsSource);
    };
    TreeListItemsViewModel.displayName = 'TreeListItemsViewModel';
    return TreeListItemsViewModel;
}(ListItemsViewModel_1.ListItemsViewModel));
exports.TreeListItemsViewModel = TreeListItemsViewModel;
//# sourceMappingURL=TreeListItemsViewModel.js.map