/// <reference types="react" />
import * as React from 'react';
import { Property } from '../../../WebRx';
export declare function renderLoadable(isLoading: Property<boolean> | boolean | undefined | null, loadingComponent?: React.ReactNode | (() => React.ReactNode), loadedComponent?: () => React.ReactNode): {} | null | undefined;
export declare function renderSizedLoadable(isLoading: Property<boolean> | boolean | undefined | null, text: string, fontSize: number | string, loadedComponent?: () => React.ReactNode): {} | null | undefined;
export declare function renderGridLoadable(isLoading: Property<boolean> | boolean | undefined | null, text: string, fontSize: number | string, loadedComponent?: () => React.ReactNode): {} | null | undefined;
export interface LoadingProps {
    progress?: Property<number> | number;
    text?: string;
    fontSize?: number | string;
    componentClass?: any;
}
export interface LoadingComponentProps extends React.HTMLProps<any>, LoadingProps {
}
export declare class Loading extends React.Component<LoadingComponentProps> {
    static displayName: string;
    static readonly renderLoadable: typeof renderLoadable;
    static readonly renderSizedLoadable: typeof renderSizedLoadable;
    static readonly renderGridLoadable: typeof renderGridLoadable;
    static defaultProps: Partial<LoadingProps>;
    private changedSubscription;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private getProgressValue();
}
