/// <reference types="react" />
import * as React from 'react';
import { Modal, ModalProps } from 'react-bootstrap';
import { Observable } from 'rxjs';
import { Command } from '../../../WebRx';
import { BaseView, BaseViewProps } from '../../React';
import { ModalDialogViewModel } from './ModalDialogViewModel';
export declare type BootstrapModalProps = Omit2<ModalProps, React.HTMLProps<Modal>, {
    onHide: () => void;
}>;
export interface ModalDialogProps extends BootstrapModalProps {
    modalTitle?: {};
    modalBody?: {};
    modalFooter?: {};
    canClose?: boolean;
    acceptCommand?: Command | ((ctx: {}) => Command | undefined);
    acceptCommandParameter?: any;
}
export interface ModalDialogViewProps extends BaseViewProps<ModalDialogViewModel<any>>, ModalDialogProps {
}
export declare class ModalDialogView extends BaseView<ModalDialogViewProps, ModalDialogViewModel<any>> {
    static displayName: string;
    static defaultProps: Partial<ModalDialogProps>;
    constructor(props: any);
    updateOn(viewModel: Readonly<ModalDialogViewModel<any>>): Observable<boolean>[];
    render(): {} | null | undefined;
    private renderHeader();
    private renderBody();
    private renderFooter();
    private handleKeyDown(e);
}
