Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var React_1 = require("../../React");
var ModalDialogView = /** @class */ (function (_super) {
    tslib_1.__extends(ModalDialogView, _super);
    function ModalDialogView(props) {
        var _this = _super.call(this, props) || this;
        _this.handleKeyDown = _this.handleKeyDown.bind(_this);
        return _this;
    }
    ModalDialogView.prototype.updateOn = function (viewModel) {
        return [viewModel.isVisible.changed];
    };
    ModalDialogView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var modalTitle = x.modalTitle, modalBody = x.modalBody, modalFooter = x.modalFooter, canClose = x.canClose, acceptCommand = x.acceptCommand, acceptCommandParameter = x.acceptCommandParameter;
            return {
                modalTitle: modalTitle,
                modalBody: modalBody,
                modalFooter: modalFooter,
                canClose: canClose,
                acceptCommand: acceptCommand,
                acceptCommandParameter: acceptCommandParameter,
            };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return this.wxr.renderConditional(this.viewModel.isVisible, function () { return (React.createElement(react_bootstrap_1.Modal, tslib_1.__assign({ className: _this.wxr.classNames('ModalDialog', className), autoFocus: true, keyboard: props.canClose === true, enforceFocus: props.canClose === false, backdrop: props.canClose === false ? 'static' : true, show: _this.viewModel.isVisible.value, onHide: _this.bindEventToCommand(function (x) { return x.hide; }) }, _this.trimProps(rest)),
            _this.renderHeader(),
            _this.renderBody(),
            _this.renderFooter())); });
    };
    ModalDialogView.prototype.renderHeader = function () {
        var titleContent = this.props.modalTitle && (React.createElement(react_bootstrap_1.Modal.Title, null, this.props.modalTitle instanceof Function
            ? this.props.modalTitle(this)
            : this.props.modalTitle));
        return (titleContent &&
            this.props.canClose && (React.createElement(react_bootstrap_1.Modal.Header, { closeButton: this.props.canClose === true }, titleContent)));
    };
    ModalDialogView.prototype.renderBody = function () {
        return (this.props.modalBody && (React.createElement(react_bootstrap_1.Modal.Body, { onKeyDown: this.handleKeyDown }, this.props.modalBody instanceof Function
            ? this.props.modalBody(this)
            : this.props.modalBody)));
    };
    ModalDialogView.prototype.renderFooter = function () {
        if (!this.props.modalFooter) {
            return false;
        }
        var footer = this.props.modalFooter instanceof Function
            ? this.props.modalFooter(this)
            : this.props.modalFooter;
        return footer && React.createElement(react_bootstrap_1.Modal.Footer, null, footer);
    };
    ModalDialogView.prototype.handleKeyDown = function (e) {
        if (this.props.acceptCommand && e.keyCode === 13) {
            var ctx = this.viewModel.context.value;
            var cmd = this.props.acceptCommand instanceof Function
                ? this.props.acceptCommand(ctx)
                : this.props.acceptCommand;
            var param_1 = this.props.acceptCommandParameter instanceof Function
                ? this.props.acceptCommandParameter(ctx)
                : this.props.acceptCommandParameter;
            if (cmd && cmd.canExecuteFor(param_1)) {
                return cmd.execute(param_1);
            }
        }
        return undefined;
    };
    ModalDialogView.displayName = 'ModalDialogView';
    ModalDialogView.defaultProps = {
        canClose: false,
        modalFooter: function (view) { return view.props.children; },
    };
    return ModalDialogView;
}(React_1.BaseView));
exports.ModalDialogView = ModalDialogView;
//# sourceMappingURL=ModalDialogView.js.map