Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var React_1 = require("../../React");
var ModalDialogViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(ModalDialogViewModel, _super);
    function ModalDialogViewModel(context) {
        var _this = _super.call(this) || this;
        _this.show = _this.wx.command(function () { return true; });
        _this.hide = _this.wx.command(function () { return false; });
        // any context observable result will generate a new context property changed event
        _this.context = _this.wx.getObservable(context).toProperty(undefined, false);
        _this.isVisible = rxjs_1.Observable.merge(_this.wx.whenAny(_this.context, function (x) { return x != null; }), _this.show.results, _this.hide.results).toProperty(false);
        return _this;
    }
    ModalDialogViewModel.prototype.hideOnExecute = function (command) {
        if (command != null) {
            this.addSubscription(rxjs_1.Observable.merge(this.isVisible.changed, command.results.map(function () { return false; }), command.thrownErrors.map(function () { return false; }))
                .distinctUntilChanged()
                .filter(function (x) { return x === false; })
                .invokeCommand(this.hide));
        }
        else {
            this.logger.warn('hideOnExecute called with null command');
        }
        return command;
    };
    ModalDialogViewModel.displayName = 'ModalDialogViewModel';
    return ModalDialogViewModel;
}(React_1.BaseViewModel));
exports.ModalDialogViewModel = ModalDialogViewModel;
//# sourceMappingURL=ModalDialogViewModel.js.map