Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_fa_1 = require("react-fa");
var CommandButton_1 = require("../CommandButton/CommandButton");
var NavButton = /** @class */ (function (_super) {
    tslib_1.__extends(NavButton, _super);
    function NavButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NavButton.prototype.render = function () {
        var _a = this.props, compact = _a.compact, componentProps = _a.componentProps;
        if (compact) {
            return (React.createElement("div", tslib_1.__assign({ className: this.wxr.classNames('NavButton', 'NavButton-compact') }, componentProps), this.renderButton()));
        }
        return (React.createElement("div", tslib_1.__assign({ className: this.wxr.classNames('NavButton', 'NavButton-container') }, componentProps),
            this.renderContent(),
            this.renderButton()));
    };
    NavButton.prototype.renderContent = function () {
        return React.createElement("div", { className: "NavButton-content" }, this.props.children);
    };
    NavButton.prototype.renderButton = function () {
        var _a = this.restProps(function (x) {
            var iconSize = x.iconSize, iconName = x.iconName, componentProps = x.componentProps, compact = x.compact;
            return { iconSize: iconSize, iconName: iconName, componentProps: componentProps, compact: compact };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return (React.createElement(CommandButton_1.CommandButton, tslib_1.__assign({}, rest, { className: className }),
            React.createElement(react_fa_1.Icon, { name: props.iconName, size: props.iconSize, fixedWidth: true })));
    };
    NavButton.displayName = 'NavButton';
    NavButton.defaultProps = {
        bsStyle: 'link',
        iconSize: 'lg',
        iconName: 'chevron-right',
    };
    return NavButton;
}(React.Component));
exports.NavButton = NavButton;
//# sourceMappingURL=NavButton.js.map