Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var rxjs_1 = require("rxjs");
var ObservableWrapper = /** @class */ (function (_super) {
    tslib_1.__extends(ObservableWrapper, _super);
    function ObservableWrapper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ObservableWrapper.prototype.componentWillMount = function () {
        var _this = this;
        this.property = this.wx.getObservable(this.props.observable).toProperty();
        this.subscription = this.wx
            .whenAny(this.property, function (x) { return x; })
            .subscribe(function (value) {
            _this.setState(function (prevState, props) {
                return {
                    value: value,
                };
            });
        });
    };
    ObservableWrapper.prototype.componentWillUnmount = function () {
        this.property = rxjs_1.Subscription.unsubscribe(this.property);
        this.subscription = rxjs_1.Subscription.unsubscribe(this.subscription);
    };
    ObservableWrapper.prototype.render = function () {
        return this.props.render(this.state.value) || null;
    };
    ObservableWrapper.defaultProps = {
        render: function (x) { return x; },
    };
    return ObservableWrapper;
}(React.Component));
exports.ObservableWrapper = ObservableWrapper;
//# sourceMappingURL=ObservableWrapper.js.map