/// <reference types="react" />
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { PageFooterViewModel, ViewportDimensions } from './PageFooterViewModel';
export interface PageFooterProps {
    copyright?: string | boolean;
    copyrightYear?: number | string;
    copyrightUri?: string;
    footerContent?: any;
    hideDimensions?: boolean;
    responsive?: boolean;
}
export interface PageFooterViewProps extends BaseViewProps<PageFooterViewModel>, PageFooterProps {
}
export declare class PageFooterView extends BaseView<PageFooterViewProps, PageFooterViewModel> {
    static displayName: string;
    static defaultProps: Partial<PageFooterProps>;
    constructor(props: any);
    private getDimensions();
    updateOn(viewModel: Readonly<PageFooterViewModel>): Observable<ViewportDimensions>[];
    render(): JSX.Element;
    private renderCopyrightYear();
    private renderCopyrightText();
    private renderDimensions();
}
