Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var moment = require("moment");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var rxjs_1 = require("rxjs");
var React_1 = require("../../React");
var PageFooterView = /** @class */ (function (_super) {
    tslib_1.__extends(PageFooterView, _super);
    function PageFooterView(props) {
        var _this = _super.call(this, props) || this;
        _this.bindObservableToCommand(rxjs_1.Observable.merge(rxjs_1.Observable.fromEvent(window, 'resize'), rxjs_1.Observable.fromEvent(window, 'orientationchange'))
            .startWith(undefined)
            .map(function () { return _this.getDimensions(); }), function (x) { return x.viewportDimensionsChanged; });
        return _this;
    }
    PageFooterView.prototype.getDimensions = function () {
        return {
            width: window.innerWidth,
            height: window.innerHeight,
        };
    };
    PageFooterView.prototype.updateOn = function (viewModel) {
        return [viewModel.viewportDimensions.changed];
    };
    PageFooterView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var copyright = x.copyright, copyrightYear = x.copyrightYear, copyrightUri = x.copyrightUri, footerContent = x.footerContent, hideDimensions = x.hideDimensions, responsive = x.responsive;
            return {
                copyright: copyright,
                copyrightYear: copyrightYear,
                copyrightUri: copyrightUri,
                footerContent: footerContent,
                hideDimensions: hideDimensions,
                responsive: responsive,
            };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        var copyrightContent = this.wxr.renderConditional(props.copyright !== false, function () { return (React.createElement("span", { className: "PageFooter-text" }, "\u00A9 " + _this.renderCopyrightYear() + " ",
            _this.renderCopyrightText())); });
        var dimensions = this.wxr.renderConditional(props.hideDimensions !== true, function () { return (React.createElement("span", { className: "PageFooter-viewport PageFooter-text text-muted" }, _this.renderDimensions())); });
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('PageFooter', className) }),
            React.createElement(react_bootstrap_1.Grid, { fluid: props.responsive },
                React.createElement(react_bootstrap_1.Row, null,
                    React.createElement(react_bootstrap_1.Col, { md: 12 },
                        React.createElement("div", { className: "PageFooter-container" },
                            copyrightContent,
                            this.wxr.renderConditional(copyrightContent != null && dimensions != null, function () { return (React.createElement("span", { className: "PageFooter-spacer text-muted" }, " | ")); }),
                            dimensions))),
                props.footerContent && (React.createElement(react_bootstrap_1.Row, null,
                    React.createElement(react_bootstrap_1.Col, { md: 12 },
                        React.createElement("div", { className: "PageFooter-container" }, props.footerContent)))))));
    };
    PageFooterView.prototype.renderCopyrightYear = function () {
        return this.props.copyrightYear || moment().format('YYYY');
    };
    PageFooterView.prototype.renderCopyrightText = function () {
        return ((this.props.copyrightUri && (React.createElement("a", { href: this.props.copyrightUri }, this.props.copyright || ''))) ||
            this.props.copyright ||
            '');
    };
    PageFooterView.prototype.renderDimensions = function () {
        var dim = this.viewModel.viewportDimensions.value;
        return this.wxr.renderConditional(dim == null || dim.width === 0 || dim.height === 0, function () { return 'Measuring...'; }, function () { return "Viewport: " + dim.width + "x" + dim.height; });
    };
    PageFooterView.displayName = 'PageFooterView';
    PageFooterView.defaultProps = {};
    return PageFooterView;
}(React_1.BaseView));
exports.PageFooterView = PageFooterView;
//# sourceMappingURL=PageFooterView.js.map