/// <reference types="react" />
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { PageHeaderViewModel } from './PageHeaderViewModel';
export interface PageHeaderProps {
    brand?: any;
    branduri?: string;
    responsive?: boolean;
}
export interface PageHeaderViewProps extends BaseViewProps<PageHeaderViewModel>, PageHeaderProps {
}
export declare class PageHeaderView extends BaseView<PageHeaderViewProps, PageHeaderViewModel> {
    static displayName: string;
    static defaultProps: Partial<PageHeaderProps>;
    private containerRef;
    private navBarRef;
    updateOn(viewModel: Readonly<PageHeaderViewModel>): Observable<any>[];
    private isSidebarEnabled();
    private isActionDisabled(item);
    private getOrderedActions<T>(items);
    private getVisibleActions(items);
    loaded(): void;
    render(): JSX.Element;
    private layoutNavBar();
    private renderBrandButton();
    private renderHeaderMenu(id, header, items, noCaret?, className?);
    private renderHeaderCommandActionIcon(item, className?, fixedWidth?);
    private renderRoutedMenus();
    private renderHelpMenu();
    private renderAdminMenu();
    private renderUserMenu();
    private renderSearch();
    private renderRoutedActions();
    private renderSidebar();
}
