import { Command, Property, ReadOnlyProperty } from '../../../WebRx';
import { BaseViewModel, HeaderCommandAction, HeaderMenu } from '../../React';
import { RouteHandlerViewModel } from '../RouteHandler/RouteHandlerViewModel';
export declare class PageHeaderViewModel extends BaseViewModel {
    readonly routeHandler: RouteHandlerViewModel;
    readonly staticSidebarMenus: HeaderMenu[];
    readonly staticNavbarMenus: HeaderMenu[];
    readonly staticNavbarActions: HeaderCommandAction[];
    readonly staticHelpMenuItems: HeaderCommandAction[];
    readonly staticAdminMenuItems: HeaderCommandAction[];
    readonly staticUserMenuItems: HeaderCommandAction[];
    userImage: string | undefined;
    userDisplayName: string | undefined;
    homeLink: string;
    static displayName: string;
    private dynamicSubscriptions;
    search: {} | undefined;
    readonly sidebarMenus: Property<HeaderMenu[]>;
    readonly navbarMenus: Property<HeaderMenu[]>;
    readonly navbarActions: Property<HeaderCommandAction[]>;
    readonly helpMenuItems: Property<HeaderCommandAction[]>;
    readonly adminMenuItems: Property<HeaderCommandAction[]>;
    readonly userMenuItems: Property<HeaderCommandAction[]>;
    readonly isSidebarVisible: ReadOnlyProperty<boolean>;
    readonly menuItemSelected: Command<HeaderCommandAction>;
    readonly menuItemChanged: Command;
    readonly toggleSideBar: Command<boolean>;
    constructor(routeHandler: RouteHandlerViewModel, staticSidebarMenus?: HeaderMenu[], staticNavbarMenus?: HeaderMenu[], staticNavbarActions?: HeaderCommandAction[], staticHelpMenuItems?: HeaderCommandAction[], staticAdminMenuItems?: HeaderCommandAction[], staticUserMenuItems?: HeaderCommandAction[], userImage?: string | undefined, userDisplayName?: string | undefined, homeLink?: string);
    unsubscribe(): void;
    updateDynamicContent(): void;
    private addItems<T>(list, staticItems, component?, delegateSelector?);
}
