Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var React_1 = require("../../React");
var PageHeaderViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(PageHeaderViewModel, _super);
    function PageHeaderViewModel(routeHandler, staticSidebarMenus, staticNavbarMenus, staticNavbarActions, staticHelpMenuItems, staticAdminMenuItems, staticUserMenuItems, userImage, userDisplayName, homeLink) {
        if (staticSidebarMenus === void 0) { staticSidebarMenus = []; }
        if (staticNavbarMenus === void 0) { staticNavbarMenus = []; }
        if (staticNavbarActions === void 0) { staticNavbarActions = []; }
        if (staticHelpMenuItems === void 0) { staticHelpMenuItems = []; }
        if (staticAdminMenuItems === void 0) { staticAdminMenuItems = []; }
        if (staticUserMenuItems === void 0) { staticUserMenuItems = []; }
        if (homeLink === void 0) { homeLink = '#/'; }
        var _this = _super.call(this) || this;
        _this.routeHandler = routeHandler;
        _this.staticSidebarMenus = staticSidebarMenus;
        _this.staticNavbarMenus = staticNavbarMenus;
        _this.staticNavbarActions = staticNavbarActions;
        _this.staticHelpMenuItems = staticHelpMenuItems;
        _this.staticAdminMenuItems = staticAdminMenuItems;
        _this.staticUserMenuItems = staticUserMenuItems;
        _this.userImage = userImage;
        _this.userDisplayName = userDisplayName;
        _this.homeLink = homeLink;
        _this.dynamicSubscriptions = rxjs_1.Subscription.EMPTY;
        _this.menuItemSelected = _this.wx.command();
        _this.menuItemChanged = _this.wx.command();
        _this.toggleSideBar = _this.wx.command(function (isVisible) {
            return isVisible == null ? !_this.isSidebarVisible.value : isVisible;
        });
        _this.sidebarMenus = _this.wx.property(undefined, false);
        _this.navbarMenus = _this.wx.property(undefined, false);
        _this.navbarActions = _this.wx.property(undefined, false);
        _this.helpMenuItems = _this.wx.property(undefined, false);
        _this.adminMenuItems = _this.wx.property(undefined, false);
        _this.userMenuItems = _this.wx.property(undefined, false);
        _this.isSidebarVisible = _this.wx
            .whenAny(_this.toggleSideBar.results, function (x) { return x; })
            .toProperty(false);
        _this.addSubscription(_this.wx
            .whenAny(_this.menuItemSelected.results, function (x) { return x; })
            .filterNull()
            .map(function () { return false; })
            .invokeCommand(_this.toggleSideBar));
        _this.wx.subscribeOrAlert(function () { return _this.wx.whenAny(_this.menuItemSelected.results, function (x) { return x; }).filterNull(); }, 'Page Header Menu Item Error', function (x) {
            if (x.command != null) {
                x.command.execute(x.commandParameter);
            }
            else if (x.uri != null && x.uri.length > 0) {
                if (x.uri[0] === '#') {
                    _this.navTo(x.uri);
                }
                else {
                    window.location.href = x.uri;
                }
            }
        });
        _this.addSubscription(_this.wx
            .whenAny(_this.routeHandler.routedComponent, function (x) { return x; })
            .subscribe(function () {
            _this.updateDynamicContent();
        }));
        return _this;
    }
    PageHeaderViewModel.prototype.unsubscribe = function () {
        _super.prototype.unsubscribe.call(this);
        this.dynamicSubscriptions = rxjs_1.Subscription.unsubscribe(this.dynamicSubscriptions);
    };
    PageHeaderViewModel.prototype.updateDynamicContent = function () {
        var component = this.routeHandler.routedComponent.value;
        this.logger.debug('Updating Page Header Dynamic Content', component);
        if (React_1.isRoutableViewModel(component)) {
            this.search = component.getSearch();
        }
        else {
            this.search = undefined;
        }
        // dispose any existing subscriptions to header actions
        this.dynamicSubscriptions = rxjs_1.Subscription.unsubscribe(this.dynamicSubscriptions);
        // add our header actions
        this.addItems(this.sidebarMenus, this.staticSidebarMenus, component, function (x) { return x.getSidebarMenus; });
        this.addItems(this.navbarMenus, this.staticNavbarMenus, component, function (x) { return x.getNavbarMenus; });
        this.addItems(this.navbarActions, this.staticNavbarActions, component, function (x) { return x.getNavbarActions; });
        this.addItems(this.helpMenuItems, this.staticHelpMenuItems, component, function (x) { return x.getHelpMenuItems; });
        this.addItems(this.adminMenuItems, this.staticAdminMenuItems, component, function (x) { return x.getAdminMenuItems; });
        this.addItems(this.userMenuItems, this.staticUserMenuItems, component, function (x) { return x.getUserMenuItems; });
    };
    PageHeaderViewModel.prototype.addItems = function (list, staticItems, component, delegateSelector) {
        var routedItems;
        // interrogate the routed component for items from the delegate selector
        if (delegateSelector != null && React_1.isRoutableViewModel(component)) {
            var selector = delegateSelector(component);
            if (selector != null) {
                routedItems = selector.apply(component);
            }
        }
        // start with all the static items
        list.value = staticItems
            // then add any routed actions
            .concat(routedItems || [])
            // finally sort the list so that we retain a consistent order
            .sort(function (a, b) { return (a.order || 0) - (b.order || 0); });
        // now that our list is populated with our header actions, subscribe to the
        // canExecute observable to manage the disabled status of any header action
        this.dynamicSubscriptions = new rxjs_1.Subscription();
        this.dynamicSubscriptions.add(rxjs_1.Observable.merge.apply(rxjs_1.Observable, tslib_1.__spread(list.value
            .map(function (x) { return (React_1.isHeaderCommandAction(x) ? x : undefined); })
            .filterNull()
            .map(function (x) { return x.command.canExecuteObservable; }))).invokeCommand(this.menuItemChanged));
    };
    PageHeaderViewModel.displayName = 'PageHeaderViewModel';
    return PageHeaderViewModel;
}(React_1.BaseViewModel));
exports.PageHeaderViewModel = PageHeaderViewModel;
//# sourceMappingURL=PageHeaderViewModel.js.map