/// <reference types="react" />
import * as React from 'react';
import { DropdownButtonProps, Pagination, PaginationProps } from 'react-bootstrap';
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { PagerViewModel } from './PagerViewModel';
export declare type BootstrapPaginationProps = Omit<PaginationProps, React.HTMLProps<Pagination>>;
export interface PagerProps extends BootstrapPaginationProps {
    info?: boolean;
    limits?: number[];
    dropdownProps?: DropdownButtonProps;
    order?: PagerComponentTypes[];
    emptyInfo?: string;
}
export interface PagerViewProps extends BaseViewProps<PagerViewModel>, PagerProps {
}
export declare type PagerComponentTypes = 'info' | 'controls' | 'limit' | undefined;
export declare const StandardPagerComponentOrder: PagerComponentTypes[];
export declare class PagerView extends BaseView<PagerViewProps, PagerViewModel> {
    static displayName: string;
    static defaultProps: Partial<PagerProps>;
    private readonly renderFunctions;
    updateOn(viewModel: Readonly<PagerViewModel>): Observable<number>[];
    render(): {} | null | undefined;
    protected isEmpty(): boolean;
    protected renderComponents(): JSX.Element;
    private shouldRenderPager();
    private shouldRenderEmpty();
    private shouldRenderInfo();
    private shouldRenderControls();
    private shouldRenderLimit();
    private renderComponent(type);
    private renderEmpty();
    private renderInfo();
    private renderControls();
    private renderLimit();
    private renderLimitTitle();
}
