import { Command, Property, ReadOnlyProperty } from '../../../WebRx';
import { BaseViewModel, HandlerRoutingStateChanged, RoutingStateHandler } from '../../React';
export declare const StandardLimits: number[];
export declare const AlwaysPagedLimits: number[];
export interface PageRequest {
    offset: number;
    limit: number;
}
export interface PagerRoutingState {
    page?: number;
    limit?: number;
}
export declare class PagerViewModel extends BaseViewModel implements RoutingStateHandler<PagerRoutingState> {
    protected readonly defaultLimit: number;
    static displayName: string;
    readonly itemCount: ReadOnlyProperty<number>;
    readonly limit: Property<number>;
    readonly selectedPage: ReadOnlyProperty<number>;
    readonly pageCount: ReadOnlyProperty<number>;
    readonly offset: ReadOnlyProperty<number>;
    readonly requests: ReadOnlyProperty<PageRequest>;
    readonly updateCount: Command<number>;
    readonly selectPage: Command<number>;
    constructor(defaultLimit?: number);
    isRoutingStateHandler(): boolean;
    createRoutingState(changed?: HandlerRoutingStateChanged): PagerRoutingState;
    applyRoutingState(state: PagerRoutingState): void;
}
