/// <reference types="react" />
import * as React from 'react';
import * as Layout from './GridLayout';
import { Panel, PanelItemContext, PanelProps } from './Panel';
export { RowDefinition, ColumnDefinition } from './GridLayout';
export interface GridRenderProps {
    /**
     * true to display a border around grid cells
     */
    border?: boolean;
}
export interface GridProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends PanelProps<T, TContext>, GridRenderProps {
}
export interface GridComponentProps extends React.HTMLProps<any>, GridProps {
}
export declare class Grid extends Panel<GridComponentProps> {
    static displayName: string;
    /**
     * Use this component to define your Row collection
     * i.e., <Grid.Rows><RowDefinition /></Grid.Rows>
     */
    static Rows: typeof Layout.GridRowDefinitions;
    /**
     * Use this component to define your Column collection
     * i.e., <Grid.Columns><ColumnDefinition /></Grid.Columns>
     */
    static Columns: typeof Layout.GridColumnDefinitions;
    render(): JSX.Element;
    renderItems(allChildren?: React.ReactNode, componentClass?: React.ReactType): ({} | null | undefined)[];
    protected renderRow(row: number, rows: Layout.GridLayoutDefinition[], colItems: React.ReactNode): {} | null | undefined;
    protected renderColumn(row: number, column: number, rows: Layout.GridLayoutDefinition[], cols: Layout.GridLayoutDefinition[], children: React.ReactChild[]): {} | null | undefined;
    protected getCellLayoutValue(def: Layout.GridLayoutDefinition): string | number | undefined;
    protected getLayout(): {
        children: React.ReactChild[];
        rows: Layout.GridLayoutDefinition[];
        cols: Layout.GridLayoutDefinition[];
    };
    protected getLayoutDefinitions(elem: Layout.GridLayoutDefinitionGroupElement | undefined): Layout.GridLayoutDefinition[];
}
