/// <reference types="react" />
import * as React from 'react';
import { Panel, PanelProps } from './Panel';
export declare enum StackPanelOrientation {
    Horizontal = 0,
    Vertical = 1,
}
export interface StackPanelProps extends PanelProps {
    /**
     * define which direction this stack panel expands
     * NOTE: you can use the StackPanelOrientation enum or just the string representation
     */
    orientation?: StackPanelOrientation | keyof typeof StackPanelOrientation;
}
export interface StackPanelComponentProps extends React.HTMLProps<any>, StackPanelProps {
}
export declare class StackPanel extends Panel<StackPanelComponentProps> {
    static displayName: string;
    static defaultOrientiation: StackPanelOrientation;
    static defaultProps: Partial<StackPanelProps>;
    render(): JSX.Element;
}
