Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Panel_1 = require("./Panel");
var StackPanelOrientation;
(function (StackPanelOrientation) {
    StackPanelOrientation[StackPanelOrientation["Horizontal"] = 0] = "Horizontal";
    StackPanelOrientation[StackPanelOrientation["Vertical"] = 1] = "Vertical";
})(StackPanelOrientation = exports.StackPanelOrientation || (exports.StackPanelOrientation = {}));
var StackPanel = /** @class */ (function (_super) {
    tslib_1.__extends(StackPanel, _super);
    function StackPanel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StackPanel.prototype.render = function () {
        var _a = this.props, orientation = _a.orientation, rest = tslib_1.__rest(_a, ["orientation"]);
        var orientationName = String.isString(orientation)
            ? orientation
            : StackPanelOrientation[orientation || StackPanel.defaultOrientiation];
        return this.renderPanel(this.wxr.classNames('StackPanel', "StackPanel-" + orientationName), rest);
    };
    StackPanel.displayName = 'StackPanel';
    StackPanel.defaultOrientiation = StackPanelOrientation.Vertical;
    StackPanel.defaultProps = {
        orientation: StackPanel.defaultOrientiation,
    };
    return StackPanel;
}(Panel_1.Panel));
exports.StackPanel = StackPanel;
//# sourceMappingURL=StackPanel.js.map