/// <reference types="react" />
import * as React from 'react';
import { Table, TableProps } from 'react-bootstrap';
import { Panel, PanelFragment, PanelItemContext, PanelItemProps, PanelTemplateProps } from './Panel';
export declare type BootstrapTableProps = Omit<TableProps, React.HTMLProps<Table>>;
export interface TablePanelProps<T = {}, TContext extends PanelItemContext = PanelItemContext> extends PanelItemProps<T, TContext>, PanelTemplateProps<TContext>, BootstrapTableProps {
    header?: PanelFragment;
    fixedLayout?: boolean;
}
export interface TablePanelComponentProps extends TablePanelProps, TableProps {
}
export declare class TablePanel extends Panel<TablePanelComponentProps> {
    static displayName: string;
    static defaultProps: Partial<TablePanelProps>;
    render(): JSX.Element;
    renderItems(children?: React.ReactNode, componentClass?: React.ReactType): React.ReactNode[];
}
