Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var Panel_1 = require("./Panel");
var TablePanel = /** @class */ (function (_super) {
    tslib_1.__extends(TablePanel, _super);
    function TablePanel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TablePanel.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var header = x.header, fixedLayout = x.fixedLayout;
            return { header: header, fixedLayout: fixedLayout };
        }), props = _a.props, rest = _a.rest;
        return this.renderPanel(this.wxr.classNames('TablePanel', {
            'TablePanel-fixedLayout': props.fixedLayout,
        }), rest, react_bootstrap_1.Table);
    };
    TablePanel.prototype.renderItems = function (children, componentClass) {
        var fragments = [];
        var itemTemplates = _super.prototype.renderItems.call(this, children, componentClass || '');
        if (this.props.header != null) {
            fragments.push(React.createElement("thead", { key: "thead" }, this.props.header));
        }
        fragments.push(React.createElement("tbody", { key: "tbody" }, itemTemplates));
        return fragments;
    };
    TablePanel.displayName = 'TablePanel';
    TablePanel.defaultProps = {
        fixedLayout: true,
        bordered: true,
        hover: true,
        responsive: true,
        striped: true,
    };
    return TablePanel;
}(Panel_1.Panel));
exports.TablePanel = TablePanel;
//# sourceMappingURL=TablePanel.js.map