Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var React = require("react");
var GridLayout_1 = require("./GridLayout");
var Panel_1 = require("./Panel");
var UniformGridPanel = /** @class */ (function (_super) {
    tslib_1.__extends(UniformGridPanel, _super);
    function UniformGridPanel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UniformGridPanel.defaultEmptyTemplate = function (row, column) {
        return (React.createElement("div", { key: GridLayout_1.GridLayoutDefinition.generateKey(row, column), className: "Grid-Empty" }, "\u00A0"));
    };
    UniformGridPanel.prototype.render = function () {
        var _a = this.props, gridColumns = _a.gridColumns, gridRows = _a.gridRows, firstColumn = _a.firstColumn, border = _a.border, renderEmptyRows = _a.renderEmptyRows, emptyCellTemplate = _a.emptyCellTemplate, rowClassName = _a.rowClassName, rowStyle = _a.rowStyle, rowProps = _a.rowProps, columnClassName = _a.columnClassName, columnStyle = _a.columnStyle, columnProps = _a.columnProps, rest = tslib_1.__rest(_a, ["gridColumns", "gridRows", "firstColumn", "border", "renderEmptyRows", "emptyCellTemplate", "rowClassName", "rowStyle", "rowProps", "columnClassName", "columnStyle", "columnProps"]);
        var bordered = { 'Grid-Border': border === true };
        return this.renderPanel(this.wxr.classNames('Grid', 'Grid-Uniform', bordered), rest);
    };
    UniformGridPanel.prototype.renderItems = function (children, componentClass) {
        var _this = this;
        var itemTemplates = _super.prototype.renderItems.call(this, children, componentClass);
        var index = 0 - this.props.firstColumn;
        return ix_1.Iterable.range(0, this.props.gridRows)
            .map(function (row) {
            if (_this.props.renderEmptyRows !== true &&
                index >= itemTemplates.length) {
                return undefined;
            }
            return ix_1.Iterable.range(0, _this.props.gridColumns)
                .map(function (column) {
                var isBeforeFirstItem = index < 0;
                var isAfterLastItem = index >= itemTemplates.length;
                var itemTemplate = isBeforeFirstItem || isAfterLastItem
                    ? _this.renderEmptyCell(row, column, index)
                    : itemTemplates[index];
                var item = itemTemplate != null && React.isValidElement(itemTemplate)
                    ? React.cloneElement(itemTemplate, {
                        key: GridLayout_1.GridLayoutDefinition.generateKey(row, column),
                    })
                    : itemTemplate;
                var context = { row: row, column: column, index: index++ };
                var colClassName = Panel_1.Panel.getPanelItemPropValue(_this.props.columnClassName, context);
                var colStyle = Panel_1.Panel.getPanelItemPropValue(_this.props.columnStyle, context);
                var colProps = Panel_1.Panel.getPanelItemPropValue(_this.props.columnProps, context) ||
                    {};
                return (React.createElement("div", tslib_1.__assign({ key: GridLayout_1.GridLayoutDefinition.generateKey(row, column), style: colStyle, className: _this.wxr.classNames('Grid-Column', colClassName) }, colProps), item));
            })
                .toArray();
        })
            .filterNull()
            .map(function (cols, row) {
            var context = { row: row, index: index };
            var rowClassName = Panel_1.Panel.getPanelItemPropValue(_this.props.rowClassName, context);
            var rowStyle = Panel_1.Panel.getPanelItemPropValue(_this.props.rowStyle, context);
            var rowProps = Panel_1.Panel.getPanelItemPropValue(_this.props.rowProps, context) || {};
            return (React.createElement("div", tslib_1.__assign({ key: GridLayout_1.GridLayoutDefinition.generateKey(row), style: rowStyle, className: _this.wxr.classNames('Grid-Row', rowClassName) }, rowProps), cols));
        })
            .toArray();
    };
    UniformGridPanel.prototype.renderEmptyCell = function (row, column, index) {
        return this.renderItem((this.props.emptyCellTemplate || UniformGridPanel.defaultEmptyTemplate)(row, column), index);
    };
    UniformGridPanel.displayName = 'UniformGridPanel';
    UniformGridPanel.defaultProps = {
        firstColumn: 0,
    };
    return UniformGridPanel;
}(Panel_1.Panel));
exports.UniformGridPanel = UniformGridPanel;
//# sourceMappingURL=UniformGridPanel.js.map