Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var react_fa_1 = require("react-fa");
var CommandButton_1 = require("../CommandButton/CommandButton");
var ContentTooltip_1 = require("../ContentTooltip/ContentTooltip");
var Breadcrumbs = /** @class */ (function (_super) {
    tslib_1.__extends(Breadcrumbs, _super);
    function Breadcrumbs(props) {
        var _this = _super.call(this, props) || this;
        _this.toggleBreadcrumbsPin = _this.toggleBreadcrumbsPin.bind(_this);
        return _this;
    }
    Breadcrumbs.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var pinnable = x.pinnable, items = x.items;
            return { pinnable: pinnable, items: items };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return this.wxr.renderIterable(props.items, function (x, i, a) {
            return _this.renderCrumb(x, i, i === a.length - 1);
        }, function (x) {
            return x.length === 0 ? null : (React.createElement("div", tslib_1.__assign({}, rest, { className: _this.wxr.classNames('Breadcrumbs', 'hidden-xs', className) }),
                React.createElement("div", { className: "Breadcrumbs-container" },
                    React.createElement(react_bootstrap_1.Breadcrumb, null, x),
                    _this.wxr.renderConditional(props.pinnable, function () { return (React.createElement(CommandButton_1.CommandButton, { className: "Breadcrumbs-pin", bsStyle: "link", onClick: _this.toggleBreadcrumbsPin },
                        React.createElement(react_fa_1.Icon, { name: "thumb-tack", size: "lg", rotate: "90" }))); }))));
        });
    };
    Breadcrumbs.prototype.renderCrumb = function (crumb, index, active) {
        var breadcrumb = (React.createElement(react_bootstrap_1.Breadcrumb.Item, { key: crumb.key, active: active, href: crumb.href, title: crumb.title, target: crumb.target }, crumb.content));
        return ((crumb.tooltip && (React.createElement(ContentTooltip_1.ContentTooltip, { key: crumb.key, id: crumb.key + "-tt", content: crumb.tooltip, context: breadcrumb, placement: crumb.tooltip.placement || 'bottom' }))) ||
            breadcrumb);
    };
    Breadcrumbs.prototype.toggleBreadcrumbsPin = function () {
        var elem = document.getElementById(this.props.id);
        if (elem != null) {
            if (/fixed/.test(elem.className)) {
                elem.className = 'Breadcrumbs';
            }
            else {
                elem.className = 'Breadcrumbs fixed';
            }
        }
    };
    Breadcrumbs.defaultProps = {
        id: 'breadcrumbs',
    };
    return Breadcrumbs;
}(React.Component));
exports.Breadcrumbs = Breadcrumbs;
//# sourceMappingURL=Breadcrumbs.js.map