Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var react_fa_1 = require("react-fa");
var React_1 = require("../../React");
var BindableInput_1 = require("../BindableInput/BindableInput");
var CommandButton_1 = require("../CommandButton/CommandButton");
var EnterKey = 13;
var SearchView = /** @class */ (function (_super) {
    tslib_1.__extends(SearchView, _super);
    function SearchView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SearchView.prototype.updateOn = function (viewModel) {
        return [viewModel.searchPending.changed];
    };
    SearchView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var placeholder = x.placeholder;
            return { placeholder: placeholder };
        }), className = _a.className, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('Search', className) }),
            React.createElement(react_bootstrap_1.FormGroup, null,
                React.createElement(BindableInput_1.BindableInput, { boundProperty: this.viewModel.filter },
                    React.createElement(react_bootstrap_1.FormControl, { className: "Search-text", type: "text", placeholder: this.props.placeholder, onKeyDown: this.bindEventToCommand(function (x) { return x.search; }, undefined, function (e) { return e.keyCode === EnterKey; }) })),
                this.wxr.renderConditional(this.viewModel.searchPending, function () { return (React.createElement(react_fa_1.Icon, { className: "Search-icon Search-pendingIcon", name: "spinner", pulse: true })); }, function () {
                    return _this.wxr.renderConditional(String.isNullOrEmpty(_this.viewModel.filter.value) === false, function () { return (React.createElement(CommandButton_1.CommandButton, { className: "Search-icon Search-clearIcon", plain: true, command: _this.viewModel.clear },
                        React.createElement(react_fa_1.Icon, { name: "times" }))); });
                }),
                React.createElement(CommandButton_1.CommandButton, { className: "Search-icon", plain: true, command: this.viewModel.search },
                    React.createElement(react_fa_1.Icon, { name: "search" })))));
    };
    SearchView.displayName = 'SearchView';
    SearchView.defaultProps = {
        placeholder: 'Search',
    };
    return SearchView;
}(React_1.BaseView));
exports.SearchView = SearchView;
//# sourceMappingURL=SearchView.js.map