Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var Loading_1 = require("../Loading/Loading");
var Splash = /** @class */ (function (_super) {
    tslib_1.__extends(Splash, _super);
    function Splash() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Splash.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var header = x.header, logo = x.logo, text = x.text, progress = x.progress, fluid = x.fluid;
            return { header: header, logo: logo, text: text, progress: progress, fluid: fluid };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('Splash', className) }),
            React.createElement(react_bootstrap_1.Grid, { fluid: props.fluid },
                React.createElement(react_bootstrap_1.Row, null,
                    React.createElement("div", { className: "Splash-header" },
                        this.renderLogo(),
                        React.createElement("span", { className: "Splash-headerText" }, props.header)),
                    React.createElement(Loading_1.Loading, { progress: props.progress, text: props.text, fontSize: "24pt" })))));
    };
    Splash.prototype.renderLogo = function () {
        var _this = this;
        return this.wxr.renderConditional(this.props.logo != null, function () { return (React.createElement(react_bootstrap_1.Image, { className: "Splash-logo", src: _this.props.logo, rounded: true })); });
    };
    Splash.displayName = 'Splash';
    Splash.defaultProps = {
        fluid: false,
    };
    return Splash;
}(React.Component));
exports.Splash = Splash;
//# sourceMappingURL=Splash.js.map