/// <reference types="react" />
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../../React';
import { TabsViewModel } from './TabsViewModel';
export declare class TabRenderTemplate<T> {
    protected readonly titleSelector: (item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => string;
    protected readonly renderItem: (item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => any;
    protected readonly keySelector: (item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => any;
    static displayName: string;
    protected readonly renderTemplateContainer: (content: () => any, item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => any;
    constructor(titleSelector: (item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => string, renderItem?: (item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => any, keySelector?: (item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => any, renderTemplateContainer?: (content: () => any, item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView) => any);
    protected renderDefaultTemplateContainer(content: () => any, item: T, index: number, viewModel: Readonly<TabsViewModel<T>>, view: TabsView): JSX.Element;
    render(viewModel: Readonly<TabsViewModel<T>>, view: TabsView): any[];
}
export interface TabsProps<T = {}> {
    template?: TabRenderTemplate<T>;
}
export interface TabsViewProps extends BaseViewProps<TabsViewModel<{}>>, TabsProps {
}
export declare class TabsView extends BaseView<TabsViewProps, TabsViewModel<{}>> {
    static displayName: string;
    updateOn(viewModel: Readonly<TabsViewModel<{}>>): (Observable<number> | Observable<{}[]>)[];
    render(): JSX.Element;
    private renderTabs();
    private renderStaticTabs();
    private renderDynamicTabs(template);
}
