// tslint:disable:max-classes-per-file
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var React_1 = require("../../React");
var TabRenderTemplate = /** @class */ (function () {
    function TabRenderTemplate(titleSelector, renderItem, keySelector, renderTemplateContainer) {
        if (renderItem === void 0) { renderItem = function (x) { return x.toString(); }; }
        if (keySelector === void 0) { keySelector = function (x, i) { return i; }; }
        this.titleSelector = titleSelector;
        this.renderItem = renderItem;
        this.keySelector = keySelector;
        this.renderTemplateContainer =
            renderTemplateContainer || this.renderDefaultTemplateContainer;
    }
    TabRenderTemplate.prototype.renderDefaultTemplateContainer = function (content, item, index, viewModel, view) {
        return (React.createElement(react_bootstrap_1.Tab, { key: this.keySelector(item, index, viewModel, view), title: this.titleSelector(item, index, viewModel, view), eventKey: index }, TabsView.wxr.renderConditional(index === viewModel.selectedIndex.value, content)));
    };
    TabRenderTemplate.prototype.render = function (viewModel, view) {
        var _this = this;
        return viewModel.tabs.value.map(function (x, i) {
            return _this.renderTemplateContainer(function () { return _this.renderItem(x, i, viewModel, view); }, x, i, viewModel, view);
        });
    };
    TabRenderTemplate.displayName = 'TabViewTemplate';
    return TabRenderTemplate;
}());
exports.TabRenderTemplate = TabRenderTemplate;
var TabsView = /** @class */ (function (_super) {
    tslib_1.__extends(TabsView, _super);
    function TabsView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TabsView.prototype.updateOn = function (viewModel) {
        return [viewModel.tabs.changed, viewModel.selectedIndex.changed];
    };
    TabsView.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var template = x.template, children = x.children;
            return { template: template, children: children };
        }), className = _a.className, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('Tabs', className) }), this.renderTabs()));
    };
    TabsView.prototype.renderTabs = function () {
        return ((this.props.template && this.renderDynamicTabs(this.props.template)) ||
            this.renderStaticTabs());
    };
    TabsView.prototype.renderStaticTabs = function () {
        return (React.createElement(react_bootstrap_1.Tabs, { id: this.props.id, unmountOnExit: true, activeKey: this.viewModel.selectedIndex.value, onSelect: this.bindEventToCommand(function (x) { return x.selectIndex; }) }, React.Children.map(this.props.children, function (x, i) {
            return React.cloneElement(x, { eventKey: i });
        })));
    };
    TabsView.prototype.renderDynamicTabs = function (template) {
        return (React.createElement(react_bootstrap_1.Tabs, { id: this.props.id, activeKey: this.viewModel.selectedIndex.value, onSelect: this.bindEventToCommand(function (x) { return x.selectIndex; }) }, template.render(this.viewModel, this)));
    };
    TabsView.displayName = 'TabsView';
    return TabsView;
}(React_1.BaseView));
exports.TabsView = TabsView;
//# sourceMappingURL=TabsView.js.map