import { Command, ReadOnlyProperty } from '../../../WebRx';
import { BaseViewModel, HandlerRoutingStateChanged, RoutingStateHandler } from '../../React';
export interface TabsRoutingState {
    tab?: number;
}
export declare class TabsViewModel<T = any> extends BaseViewModel implements RoutingStateHandler<TabsRoutingState> {
    static displayName: string;
    readonly tabs: ReadOnlyProperty<T[]>;
    readonly selectedTab: ReadOnlyProperty<T>;
    readonly selectedIndex: ReadOnlyProperty<number>;
    readonly addTab: Command<T>;
    readonly removeTab: Command<T | number>;
    readonly selectTab: Command<T>;
    readonly selectIndex: Command<number>;
    constructor(initialTabs?: T[]);
    isRoutingStateHandler(): boolean;
    createRoutingState(changed?: HandlerRoutingStateChanged): TabsRoutingState;
    applyRoutingState(state: TabsRoutingState): void;
}
