Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React_1 = require("../../React");
var TabsViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(TabsViewModel, _super);
    function TabsViewModel(initialTabs) {
        if (initialTabs === void 0) { initialTabs = []; }
        var _this = _super.call(this) || this;
        var tabs = _this.wx.property(initialTabs, false);
        _this.tabs = tabs;
        _this.addTab = _this.wx.command(function (tab) {
            tabs.value = _this.tabs.value.concat(tab);
            return tab;
        });
        _this.removeTab = _this.wx.command(function (tab) {
            tabs.value = Number.isNumeric(tab)
                ? _this.tabs.value.filter(function (x, i) { return i !== tab; })
                : _this.tabs.value.filter(function (x) { return x !== tab; });
            return tab;
        });
        _this.selectTab = _this.wx.command();
        _this.selectIndex = _this.wx.command();
        _this.selectedTab = _this.wx
            .whenAny(_this.selectIndex.results, function (x) { return _this.tabs.value[x]; })
            .toProperty();
        _this.selectedIndex = _this.wx
            .whenAny(_this.selectIndex.results, function (x) { return x; })
            .toProperty(1);
        _this.addSubscription(_this.selectTab.results
            .map(function (x) { return _this.tabs.value.indexOf(x); })
            .invokeCommand(_this.selectIndex));
        _this.addSubscription(_this.wx
            .whenAny(_this.tabs.changed, function (x) { return ({
            i: _this.selectedIndex.value,
            l: x.length,
        }); })
            .filter(function (x) { return x.l > 0 && (x.i == null || x.i < 0 || x.i >= x.l); })
            .map(function (x) { return x.l - 1; })
            .invokeCommand(_this.selectIndex));
        _this.addSubscription(_this.wx.whenAny(_this.selectedIndex, function (x) { return x; }).subscribe(function (x) {
            _this.notifyChanged(x);
        }));
        return _this;
    }
    TabsViewModel.prototype.isRoutingStateHandler = function () {
        return true;
    };
    TabsViewModel.prototype.createRoutingState = function (changed) {
        return Object.trim({
            tab: this.getRoutingStateValue(this.selectedIndex.value, 0),
        });
    };
    TabsViewModel.prototype.applyRoutingState = function (state) {
        if (this.selectedIndex.value !== state.tab) {
            this.selectIndex.execute(state.tab == null ? 0 : state.tab);
        }
    };
    TabsViewModel.displayName = 'TabsViewModel';
    return TabsViewModel;
}(React_1.BaseViewModel));
exports.TabsViewModel = TabsViewModel;
//# sourceMappingURL=TabsViewModel.js.map