/// <reference types="react" />
import { Observable } from 'rxjs';
import { BaseView, BaseViewProps } from '../React';
import { ComponentDemoViewModel } from './ComponentDemoViewModel';
import './ComponentDemo.less';
export declare type ViewActivator = (component: any, componentRoute: string | undefined, responsive: boolean | undefined) => any;
export interface ViewActivatorMap {
    [key: string]: ViewActivator;
}
export interface ComponentDemoProps {
    viewMap: ViewActivatorMap;
    responsive?: boolean;
}
export interface ComponentDemoViewProps extends BaseViewProps<ComponentDemoViewModel>, ComponentDemoProps {
}
export declare class ComponentDemoView extends BaseView<ComponentDemoViewProps, ComponentDemoViewModel> {
    static displayName: string;
    updateOn(viewModel: Readonly<ComponentDemoViewModel>): Observable<any>[];
    render(): JSX.Element;
    private getComponentName();
    private renderHeader();
    private renderComponentView();
    private renderDropdown(cols);
}
