Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ix_1 = require("ix");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var React_1 = require("../React");
require("./ComponentDemo.less");
var ComponentDemoView = /** @class */ (function (_super) {
    tslib_1.__extends(ComponentDemoView, _super);
    function ComponentDemoView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ComponentDemoView.prototype.updateOn = function (viewModel) {
        return [viewModel.columns.changed, viewModel.component.changed];
    };
    ComponentDemoView.prototype.render = function () {
        var _this = this;
        var _a = this.restProps(function (x) {
            var viewMap = x.viewMap, responsive = x.responsive;
            return { viewMap: viewMap, responsive: responsive };
        }), className = _a.className, rest = _a.rest;
        var cols = this.viewModel.columns.value;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('ComponentDemo', className) }),
            React.createElement(react_bootstrap_1.Grid, { fluid: cols === 0 },
                React.createElement(react_bootstrap_1.Row, null,
                    React.createElement(react_bootstrap_1.Col, { md: 12 }, this.renderHeader())),
                React.createElement(react_bootstrap_1.Row, null, this.wxr.renderConditional(this.viewModel.componentRoute.value === 'help', function () { return _this.renderComponentView(); }, function () { return (React.createElement(react_bootstrap_1.Col, { md: cols === 0 ? 12 : cols },
                    React.createElement("div", { className: "ComponentDemo-view" }, _this.renderComponentView()))); }))),
            React.createElement(react_bootstrap_1.Grid, { className: "ComponentDemo-footer" },
                React.createElement(react_bootstrap_1.Row, null,
                    React.createElement(react_bootstrap_1.Col, { md: 12 }, this.renderDropdown(cols))))));
    };
    ComponentDemoView.prototype.getComponentName = function () {
        return this.viewModel.component.value == null
            ? 'Invalid Component'
            : Object.getName(this.viewModel.component.value);
    };
    ComponentDemoView.prototype.renderHeader = function () {
        var _this = this;
        return this.wxr.renderConditional(this.viewModel.componentRoute.value !== 'help', function () { return (React.createElement(react_bootstrap_1.PageHeader, null,
            React.createElement("span", null, _this.getComponentName() + " Demo"))); });
    };
    ComponentDemoView.prototype.renderComponentView = function () {
        var view;
        var componentName = this.getComponentName();
        var component = this.viewModel.component.value;
        if (component != null) {
            this.logger.debug("Loading View for \"" + componentName + "\"...");
            var activator = this.props.viewMap[componentName];
            if (activator != null) {
                view = activator(component, this.viewModel.componentRoute.value, this.props.responsive);
            }
        }
        if (view == null) {
            view = (React.createElement(react_bootstrap_1.Alert, { bsStyle: "danger" }, component == null
                ? "No Component for " + this.viewModel.componentRoute.value
                : "No View Mapped for " + componentName));
        }
        else {
            this.logger.debug("Rendering View...", view);
        }
        return view;
    };
    ComponentDemoView.prototype.renderDropdown = function (cols) {
        return (React.createElement(react_bootstrap_1.DropdownButton, { id: "col-width", bsStyle: "info", title: "Column Width (" + (cols === 0 ? 'Full Width' : cols) + ")", onSelect: this.bindEventToCommand(function (x) { return x.setColumns; }) }, ix_1.Iterable.range(1, 13)
            .reverse()
            .map(function (x) { return x % 13; })
            .map(function (x) { return (React.createElement(react_bootstrap_1.MenuItem, { key: x, eventKey: x, active: cols === x }, x === 0 ? 'Full Width' : x)); })
            .toArray()));
    };
    ComponentDemoView.displayName = 'ComponentDemoView';
    return ComponentDemoView;
}(React_1.BaseView));
exports.ComponentDemoView = ComponentDemoView;
//# sourceMappingURL=ComponentDemoView.js.map