import { Iterable } from 'ix';
import { RoutingMap } from './ComponentDemoViewModel';
export declare const demoRoutingMap: RoutingMap;
export interface SampleData {
    id: number;
    cat: string;
    name: string;
    requiredBy: string;
}
export interface SampleTreeData extends SampleData {
    items?: SampleTreeData[];
}
export declare function createSampleItem(cat: string, name: string, requiredBy: string, id?: number): SampleData;
export declare function cloneSampleItem<T extends SampleData>(item: T): T;
export declare function cloneSampleTreeItem(item: SampleTreeData, items: Iterable<SampleTreeData>): SampleTreeData;
export declare const sampleListData: SampleData[];
export declare const sampleTreeData: SampleTreeData[];
