Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseSampleDataStore_1 = require("../../../../Stores/SampleData/BaseSampleDataStore");
var TodoListStore_1 = require("../TodoListStore");
var TodoListStore = /** @class */ (function (_super) {
    tslib_1.__extends(TodoListStore, _super);
    function TodoListStore() {
        var _this = _super.call(this) || this;
        _this.nextId = 1;
        _this.connect(TodoListStore_1.TodoListActions.GetItems, _this.getItems);
        _this.connect(TodoListStore_1.TodoListActions.AddItem, _this.addItem);
        _this.connect(TodoListStore_1.TodoListActions.RemoveItem, _this.removeItem);
        _this.connect(TodoListStore_1.TodoListActions.SetCompleted, _this.setCompleted);
        _this.data = {
            items: [
                _this.createItem('first item', true),
                _this.createItem('second item'),
                _this.createItem('third item'),
            ],
        };
        return _this;
    }
    TodoListStore.prototype.createItem = function (content, completed) {
        if (completed === void 0) { completed = false; }
        return { id: this.nextId++, content: content, completed: completed };
    };
    TodoListStore.prototype.getItems = function () {
        return this.data.items;
    };
    TodoListStore.prototype.addItem = function (params) {
        if (params === void 0) { params = {}; }
        if (String.isString(params.content)) {
            var item = this.createItem(params.content);
            this.data.items.push(item);
            return item;
        }
        throw new Error('Invalid Params: missing content');
    };
    TodoListStore.prototype.removeItem = function (params) {
        if (params === void 0) { params = {}; }
        if (params.id != null && Number.isInteger(params.id)) {
            this.data.items = this.data.items.filter(function (x) { return x.id !== params.id; });
            return params.id;
        }
        throw new Error('Invalid Params: missing id');
    };
    TodoListStore.prototype.setCompleted = function (params) {
        if (params === void 0) { params = {}; }
        if (params.id != null && Number.isInteger(params.id)) {
            var item = this.data.items.asIterable().single(function (x) { return x.id === params.id; });
            if (item != null) {
                item.completed = params.completed === false ? false : true;
                return params.id;
            }
            throw new Error("Invalid Params: item not found for id (" + params.id + ")");
        }
        throw new Error('Invalid Params: missing id');
    };
    TodoListStore.displayName = 'TodoListStore';
    TodoListStore.default = new TodoListStore();
    return TodoListStore;
}(BaseSampleDataStore_1.BaseSampleDataStore));
exports.TodoListStore = TodoListStore;
//# sourceMappingURL=TodoListStore.js.map