import { Observable } from 'rxjs';
import { BaseApiStore } from '../../../Stores/BaseStore';
import { TodoListApi } from './TodoListApi';
export interface TodoListItem {
    id: number;
    content: string;
    completed: boolean;
}
export declare const TodoListActions: {
    GetItems: string;
    AddItem: string;
    RemoveItem: string;
    SetCompleted: string;
};
export declare class TodoListStore extends BaseApiStore<TodoListApi> {
    static displayName: string;
    static readonly default: TodoListStore;
    constructor(api?: TodoListApi);
    getItems(): Observable<TodoListItem[]>;
    addItem(content: string): Observable<TodoListItem>;
    removeItem(id: number): Observable<number>;
    setCompleted(id: number, completed: boolean): Observable<number>;
}
