Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseStore_1 = require("../../../Stores/BaseStore");
var TodoListApi_1 = require("./TodoListApi");
exports.TodoListActions = {
    GetItems: 'GetItems',
    AddItem: 'AddItem',
    RemoveItem: 'RemoveItem',
    SetCompleted: 'SetCompleted',
};
var TodoListStore = /** @class */ (function (_super) {
    tslib_1.__extends(TodoListStore, _super);
    function TodoListStore(api) {
        if (api === void 0) { api = TodoListApi_1.TodoListApi.default; }
        return _super.call(this, api) || this;
    }
    TodoListStore.prototype.getItems = function () {
        return this.getObservable(exports.TodoListActions.GetItems);
    };
    TodoListStore.prototype.addItem = function (content) {
        return this.getObservable(exports.TodoListActions.AddItem, {
            content: content,
        });
    };
    TodoListStore.prototype.removeItem = function (id) {
        return this.getObservable(exports.TodoListActions.RemoveItem, { id: id });
    };
    TodoListStore.prototype.setCompleted = function (id, completed) {
        return this.getObservable(exports.TodoListActions.SetCompleted, {
            id: id,
            completed: completed,
        });
    };
    TodoListStore.displayName = 'TodoListStore';
    TodoListStore.default = new TodoListStore();
    return TodoListStore;
}(BaseStore_1.BaseApiStore));
exports.TodoListStore = TodoListStore;
//# sourceMappingURL=TodoListStore.js.map