/// <reference types="react" />
import { Observable } from 'rxjs';
import { Command } from '../../../WebRx';
import { BaseView, BaseViewProps } from '../../React';
import { TodoItemViewModel, TodoListViewModel } from './TodoListViewModel';
import './TodoList.less';
export interface TodoListProps {
    shadow?: boolean;
}
export interface TodoListViewProps extends BaseViewProps<TodoListViewModel>, TodoListProps {
}
export declare class TodoListView extends BaseView<TodoListViewProps, TodoListViewModel> {
    private inputRef;
    constructor(props: any);
    componentDidMount(): void;
    render(): JSX.Element;
    protected renderItem(item: TodoItemViewModel): JSX.Element;
    protected renderEmptyContent(): "No todo items to show." | "No todo items have been created yet.";
    protected renderTeaser(): JSX.Element;
    protected renderFooter(): null;
    private focusInput();
}
export interface TodoItemProps {
    remove: Command<TodoItemViewModel>;
}
export interface TodoItemViewProps extends BaseViewProps<TodoItemViewModel>, TodoItemProps {
}
export declare class TodoItemView extends BaseView<TodoItemViewProps, TodoItemViewModel> {
    constructor(props: any);
    updateOn(viewModel: Readonly<TodoItemViewModel>): Observable<boolean>[];
    render(): JSX.Element;
    protected getRemoveCommand(): Command<TodoItemViewModel, any>;
}
