// tslint:disable:max-classes-per-file
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var react_fa_1 = require("react-fa");
var BindableInput_1 = require("../../Common/BindableInput/BindableInput");
var CommandButton_1 = require("../../Common/CommandButton/CommandButton");
var ItemListPanelView_1 = require("../../Common/ItemListPanel/ItemListPanelView");
var ListGroupView_1 = require("../../Common/ListItems/ListGroupView");
var React_1 = require("../../React");
require("./TodoList.less");
var TodoListView = /** @class */ (function (_super) {
    tslib_1.__extends(TodoListView, _super);
    function TodoListView(props) {
        var _this = _super.call(this, props) || this;
        _this.inputRef = React.createRef();
        _this.renderItem = _this.renderItem.bind(_this);
        _this.focusInput = _this.focusInput.bind(_this);
        return _this;
    }
    TodoListView.prototype.componentDidMount = function () {
        this.focusInput();
    };
    TodoListView.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var shadow = x.shadow;
            return { shadow: shadow };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('TodoList', className) }),
            React.createElement(ItemListPanelView_1.ItemListPanelView, { viewModel: this.viewModel.list, collapsible: true, pager: true, search: true, compact: true, emptyContent: this.renderEmptyContent(), shadow: this.props.shadow, itemTemplate: this.renderItem, headerContent: "Canonical Todo List", teaserContent: this.renderTeaser(), footerContent: this.renderFooter() },
                React.createElement(ListGroupView_1.ListGroupView, null))));
    };
    TodoListView.prototype.renderItem = function (item) {
        return React.createElement(TodoItemView, { viewModel: item, remove: this.viewModel.removeItem });
    };
    TodoListView.prototype.renderEmptyContent = function () {
        if (this.viewModel.list.count.value > 0) {
            return 'No todo items to show.';
        }
        return 'No todo items have been created yet.';
    };
    TodoListView.prototype.renderTeaser = function () {
        var _this = this;
        return (React.createElement(react_bootstrap_1.FormGroup, { className: "TodoList-teaser" },
            React.createElement(react_bootstrap_1.InputGroup, null,
                React.createElement(BindableInput_1.BindableInput, { boundProperty: this.viewModel.newItemContent },
                    React.createElement(react_bootstrap_1.FormControl, { ref: this.inputRef, id: "newItemContent", type: "text", placeholder: "Type in a todo item here...", onKeyDown: this.bindEventToCommand(function (x) { return x.addItem; }, undefined, function (_, e) { return e.keyCode === 13; }, function () { return _this.focusInput(); }) })),
                React.createElement(react_bootstrap_1.InputGroup.Button, null,
                    React.createElement(CommandButton_1.CommandButton, { bsStyle: "success", command: this.viewModel.addItem, onClick: this.focusInput },
                        React.createElement(react_fa_1.Icon, { name: "plus" }),
                        ' Add New Todo Item')))));
    };
    TodoListView.prototype.renderFooter = function () {
        return null;
    };
    TodoListView.prototype.focusInput = function () {
        this.wxr.focusElement(this.inputRef.current);
    };
    return TodoListView;
}(React_1.BaseView));
exports.TodoListView = TodoListView;
var TodoItemView = /** @class */ (function (_super) {
    tslib_1.__extends(TodoItemView, _super);
    function TodoItemView(props) {
        var _this = _super.call(this, props) || this;
        _this.getRemoveCommand = _this.getRemoveCommand.bind(_this);
        return _this;
    }
    TodoItemView.prototype.updateOn = function (viewModel) {
        return [viewModel.completed.changed];
    };
    TodoItemView.prototype.render = function () {
        var _a = this.restProps(function (x) {
            var remove = x.remove;
            return { remove: remove };
        }), className = _a.className, props = _a.props, rest = _a.rest;
        return (React.createElement("div", tslib_1.__assign({}, rest, { className: this.wxr.classNames('TodoItem', 'fa-lg', className, {
                completed: this.viewModel.completed.value,
            }) }),
            React.createElement("div", { className: "TodoItem-main" },
                React.createElement(CommandButton_1.CommandButton, { plain: true, onClick: this.bindEventToCommand(function (x) { return x.toggleCompleted; }), stopPropagation: true, preventDefault: true },
                    React.createElement(react_fa_1.Icon, { name: this.viewModel.completed.value ? 'check-circle' : 'circle-o', size: "lg", fixedWidth: true })),
                React.createElement("span", { className: "text-muted" }, "[ " + this.viewModel.id + " ] "),
                React.createElement("span", { className: "TodoItem-content" }, this.viewModel.content)),
            React.createElement("div", { className: "TodoItem-actions" },
                React.createElement(CommandButton_1.CommandButton, { bsStyle: "danger", bsSize: "xs", componentClass: "a", command: this.getRemoveCommand, commandParameter: this.viewModel },
                    React.createElement(react_fa_1.Icon, { name: "times", fixedWidth: true })))));
    };
    TodoItemView.prototype.getRemoveCommand = function () {
        return this.props.remove;
    };
    return TodoItemView;
}(React_1.BaseView));
exports.TodoItemView = TodoItemView;
//# sourceMappingURL=TodoListView.js.map