import { Command, Property, ReadOnlyProperty } from '../../../WebRx';
import { ItemListPanelRoutingState, ItemListPanelViewModel } from '../../Common/ItemListPanel/ItemListPanelViewModel';
import { BaseViewModel, HandlerRoutingStateChanged, RoutingStateHandler } from '../../React';
import { TodoListItem, TodoListStore } from './TodoListStore';
export declare class TodoListViewModel extends BaseViewModel implements RoutingStateHandler<ItemListPanelRoutingState> {
    protected store: TodoListStore;
    static displayName: string;
    newItemContent: Property<string>;
    addItem: Command;
    removeItem: Command<TodoItemViewModel>;
    list: ItemListPanelViewModel<TodoItemViewModel>;
    constructor(store?: TodoListStore);
    isRoutingStateHandler(): boolean;
    createRoutingState(changed?: HandlerRoutingStateChanged): ItemListPanelRoutingState;
    applyRoutingState(state: ItemListPanelRoutingState): void;
}
export declare class TodoItemViewModel extends BaseViewModel {
    protected store: TodoListStore;
    static displayName: string;
    private static nextId;
    readonly id: number;
    readonly content: string;
    readonly toggleCompleted: Command;
    readonly completed: ReadOnlyProperty<boolean>;
    constructor(contentOrModel: string | TodoListItem, store?: TodoListStore);
    filter(regexp: RegExp): boolean;
}
