Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseViewModel_1 = require("./BaseViewModel");
function isRoutableViewModel(value) {
    if (value == null) {
        return false;
    }
    var viewModel = value;
    return (viewModel.isRoutableViewModel instanceof Function &&
        viewModel.isRoutableViewModel());
}
exports.isRoutableViewModel = isRoutableViewModel;
var BaseRoutableViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(BaseRoutableViewModel, _super);
    function BaseRoutableViewModel() {
        var _this = _super.call(this) || this;
        _this.updateDocumentTitle = _this.wx.command(function (title) {
            return (title || '').toString();
        });
        _this.updateRoutingBreadcrumbs = _this.wx.command();
        _this.documentTitle = _this.updateDocumentTitle.results.toProperty();
        _this.breadcrumbs = _this.wx
            .whenAny(_this.updateRoutingBreadcrumbs.results, function (x) { return x; })
            .toProperty();
        return _this;
    }
    BaseRoutableViewModel.prototype.isRoutingStateHandler = function () {
        return true;
    };
    BaseRoutableViewModel.prototype.isRoutableViewModel = function () {
        return true;
    };
    // -------------------------------------------------------
    // These are overridable dynamic routing content functions
    // -------------------------------------------------------
    BaseRoutableViewModel.prototype.getRoutingKey = function () {
        return Object.getName(this);
    };
    BaseRoutableViewModel.prototype.getSearch = function () {
        return undefined;
    };
    BaseRoutableViewModel.prototype.getSidebarMenus = function () {
        return [];
    };
    BaseRoutableViewModel.prototype.getNavbarMenus = function () {
        return [];
    };
    BaseRoutableViewModel.prototype.getNavbarActions = function () {
        return [];
    };
    BaseRoutableViewModel.prototype.getHelpMenuItems = function () {
        return [];
    };
    BaseRoutableViewModel.prototype.getAdminMenuItems = function () {
        return [];
    };
    BaseRoutableViewModel.prototype.getUserMenuItems = function () {
        return [];
    };
    BaseRoutableViewModel.displayName = 'BaseRoutableViewModel';
    return BaseRoutableViewModel;
}(BaseViewModel_1.BaseViewModel));
exports.BaseRoutableViewModel = BaseRoutableViewModel;
//# sourceMappingURL=BaseRoutableViewModel.js.map