/// <reference types="react" />
import * as React from 'react';
import { Subscription } from 'rxjs';
import { Command, ObservableLike, Property } from '../../WebRx';
import { BaseViewModel } from './BaseViewModel';
/**
 * Binds an observable to a command on the view model
 */
export declare function bindObservableToCommand<TViewModel extends BaseViewModel, TInput, TResult>(viewModel: Readonly<TViewModel>, observableLike: ObservableLike<TInput>, commandSelector: (viewModel: Readonly<TViewModel>) => Command<TResult>, onNext?: (value: TInput) => void, onError?: (exception: any) => void, onCompleted?: () => void): Subscription;
/**
 * Binds a DOM event to an observable property on the view model
 */
export declare function bindEventToProperty<TViewModel extends BaseViewModel, TValue, TEvent extends Event | React.SyntheticEvent<any>>(viewModel: Readonly<TViewModel>, targetSelector: (viewModel: Readonly<TViewModel>) => Property<TValue>, valueSelector?: (eventKey: any, event: TEvent) => TValue): any;
/**
 * Binds a DOM event to an observable command on the view model
 */
export declare function bindEventToCommand<TViewModel extends BaseViewModel, TParameter, TCommand, TEvent extends Event | React.SyntheticEvent<any>>(viewModel: Readonly<TViewModel>, commandSelector: (viewModel: Readonly<TViewModel>) => Command<TCommand>, paramSelector?: (eventKey: any, event: TEvent) => TParameter, conditionSelector?: (event: TEvent, eventKey: any) => boolean, onNext?: (value: TCommand) => void, onError?: (exception: any) => void, onCompleted?: () => void): any;
