/// <reference types="react" />
import * as React from 'react';
import { RestResult } from './Object';
export declare function trimPropsStatic<T>(props: T): T;
export interface ReactSpreadResultProps {
    className?: string;
    children?: React.ReactNode;
}
export interface ReactSpreadRestrictedProps extends ReactSpreadResultProps {
    key?: React.Key;
    ref?: React.Ref<any>;
}
export interface ReactSpreadResult<P, T, R extends ReactSpreadRestrictedProps> extends RestResult<P, T, R>, ReactSpreadResultProps {
}
export declare const reactRestrictedProps: ReactSpreadRestrictedProps;
export declare function restPropsStatic<P, T, R extends ReactSpreadRestrictedProps = ReactSpreadRestrictedProps>(props: P, propsCreator?: (x: P) => T, restrictedProps?: R): ReactSpreadResult<P, T, R>;
export declare function restProps<P, T, R extends ReactSpreadRestrictedProps = ReactSpreadRestrictedProps>(this: React.Component<P>, propsCreator?: (x: P) => T, restrictedProps?: R): ReactSpreadResult<P, T, R>;
export declare function isTypeStatic<P>(elem: React.ReactElement<P>, type: string | React.ComponentClass<P> | React.SFC<P>): boolean;
export declare function isValidTypeStatic<P>(value: any, type: string | React.ComponentClass<P> | React.SFC<P>): value is React.ReactElement<P>;
declare module 'react' {
    interface Component<P> {
        trimProps: typeof trimPropsStatic;
        restProps<T, R extends ReactSpreadRestrictedProps = ReactSpreadRestrictedProps>(propsCreator?: (x: P) => T, restrictedProps?: R): ReactSpreadResult<P, T, R>;
    }
    namespace Component {
        let trimProps: typeof trimPropsStatic;
        let restProps: typeof restPropsStatic;
    }
    let isType: typeof isTypeStatic;
    let isValidType: typeof isValidTypeStatic;
}
