Object.defineProperty(exports, "__esModule", { value: true });
function isString(value) {
    return typeof value === 'string' || value instanceof String;
}
exports.isString = isString;
function isNullOrEmpty(value) {
    return value == null || value === '';
}
exports.isNullOrEmpty = isNullOrEmpty;
function stringify(value, replacer, space) {
    if (space === void 0) { space = 2; }
    var result;
    if (value != null) {
        result = value.toString();
        if (result === '[object Object]') {
            result = Object.getName(value);
            if (result === 'Object') {
                try {
                    result = JSON.stringify(value, replacer, space);
                }
                catch (e) {
                    // do nothing and result will retain the getName value
                }
            }
        }
    }
    return result;
}
exports.stringify = stringify;
String.isString = isString;
String.isNullOrEmpty = isNullOrEmpty;
String.stringify = stringify;
//# sourceMappingURL=String.js.map