Object.defineProperty(exports, "__esModule", { value: true });
var deparam = require("jquery-deparam");
var param = require("jquery-param");
var HashCodec = /** @class */ (function () {
    function HashCodec() {
    }
    HashCodec.prototype.normalizePath = function (path) {
        var matches = String.isNullOrEmpty(path)
            ? undefined
            : /^\/*(\/.*?\/?)\/*$/.exec('/' + path);
        return matches == null ? '' : matches[1];
    };
    HashCodec.prototype.getPathAndParams = function (hash) {
        var path;
        var params;
        var matches = String.isNullOrEmpty(hash)
            ? undefined
            : /#(\/[^?]*)(\?.*)/g.exec(hash);
        if (matches) {
            path = matches[1];
            params = matches[2];
        }
        else {
            path = hash;
            if (path.length > 0 && path[0] === '#') {
                path = path.substring(1);
            }
        }
        path = decodeURIComponent(this.normalizePath(path));
        return { path: path, params: params };
    };
    HashCodec.prototype.santize = function (hash) {
        return String.isNullOrEmpty(hash) || hash[0] !== '#' ? '#/' : hash;
    };
    HashCodec.prototype.encode = function (path, state, uriEncode) {
        if (uriEncode === void 0) { uriEncode = false; }
        var hash = '#' + this.normalizePath(path);
        if (state) {
            var params = param(state);
            if (uriEncode === false) {
                params = decodeURIComponent(params);
            }
            hash += params.length > 0 ? '?' + params : '';
        }
        return hash;
    };
    HashCodec.prototype.decode = function (hash, selector) {
        hash = this.santize(hash);
        var _a = this.getPathAndParams(hash), path = _a.path, params = _a.params;
        var state = {};
        if (params != null && params.length > 0) {
            var obj = deparam(params[0] === '?' ? params.substring(1) : params, true);
            if (obj) {
                state = obj;
            }
        }
        return selector(path, params, state);
    };
    HashCodec.displayName = 'HashCodec';
    HashCodec.Default = new HashCodec();
    HashCodec.NormalizePathPattern = '';
    HashCodec.HashPattern = '';
    return HashCodec;
}());
exports.HashCodec = HashCodec;
//# sourceMappingURL=HashCodec.js.map