import { AjaxRequest, Observable, Subscription } from 'rxjs';
import { Logger } from '../Utils/Logging';
import { WebRxStatic } from '../WebRx';
import { SampleDataCreator, StoreApi } from './Interfaces';
export declare class BaseStore extends Subscription {
    static displayName: string;
    protected readonly logger: Logger;
    protected readonly wx: WebRxStatic;
    protected readonly api: StoreApi;
    constructor(path: string, base?: string, sampleData?: SampleDataCreator, unsubscribe?: () => void);
    constructor(api: StoreApi, unsubscribe?: () => void);
    protected getObservable<T = any>(action: string, params?: any, options?: AjaxRequest, baseUri?: string): Observable<T>;
    protected postObservable<T = any>(action: string, data?: any, params?: any, options?: AjaxRequest, baseUri?: string): Observable<T>;
}
export declare class BaseApiStore<T extends StoreApi> extends BaseStore {
    protected readonly api: T;
    constructor(api: T, unsubscribe?: () => void);
}
