// tslint:disable:max-classes-per-file
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var Logging_1 = require("../Utils/Logging");
var WebRx_1 = require("../WebRx");
var Helpers_1 = require("./Helpers");
var ObservableApi_1 = require("./ObservableApi");
var BaseStore = /** @class */ (function (_super) {
    tslib_1.__extends(BaseStore, _super);
    function BaseStore(pathOrApi, baseOrUnsubscribe, sampleData, unsubscribe) {
        var _this = this;
        unsubscribe =
            baseOrUnsubscribe instanceof Function ? baseOrUnsubscribe : unsubscribe;
        var base = String.isString(baseOrUnsubscribe)
            ? baseOrUnsubscribe
            : undefined;
        _this = _super.call(this, unsubscribe) || this;
        _this.logger = Logging_1.getLogger(BaseStore.displayName);
        _this.wx = WebRx_1.wx;
        if (Helpers_1.isStoreApi(pathOrApi)) {
            _this.api = pathOrApi;
        }
        else {
            _this.api = new ObservableApi_1.ObservableApi(pathOrApi, base, sampleData);
        }
        _this.logger.name += " (" + _this.api.path + ")";
        _this.logger.debug('Store Created');
        return _this;
    }
    BaseStore.prototype.getObservable = function (action, params, options, baseUri) {
        return this.api.getObservable(action, params, options, baseUri);
    };
    BaseStore.prototype.postObservable = function (action, data, params, options, baseUri) {
        return this.api.postObservable(action, data, params, options, baseUri);
    };
    BaseStore.displayName = 'BaseStore';
    return BaseStore;
}(rxjs_1.Subscription));
exports.BaseStore = BaseStore;
var BaseApiStore = /** @class */ (function (_super) {
    tslib_1.__extends(BaseApiStore, _super);
    function BaseApiStore(api, unsubscribe) {
        var _this = _super.call(this, api, unsubscribe) || this;
        _this.api = api;
        return _this;
    }
    return BaseApiStore;
}(BaseStore));
exports.BaseApiStore = BaseApiStore;
//# sourceMappingURL=BaseStore.js.map