import { AjaxRequest, Observable } from 'rxjs';
import { Logging } from '../Utils';
import { HttpRequestMethod, ObservableApiError, StoreApi } from './Interfaces';
export declare function sanitizeUri(uri: string): string;
export declare function getUriFromParams(uri: string, params: any): string;
export declare function getError(xhr: XMLHttpRequest | undefined, uri: string, logger: Logging.Logger): ObservableApiError;
export declare let defaultHeaders: {
    Accept: string;
    'Content-Type': string;
};
export declare function getRequest<T>(action: string, url: string, logger: Logging.Logger, method?: HttpRequestMethod, params?: any, data?: any, options?: AjaxRequest): Observable<T>;
export declare function isStoreApi(value: any): value is StoreApi;
