import { AjaxRequest, Observable } from 'rxjs';
import { Logger } from '../Utils/Logging';
import { WebRxStatic } from '../WebRx';
import { HttpRequestMethod, SampleDataApi, SampleDataCreator, SampleDataStore, StoreApi } from './Interfaces';
export declare class ObservableApi implements StoreApi {
    static displayName: string;
    protected readonly logger: Logger;
    protected readonly wx: WebRxStatic;
    protected sampleData: SampleDataApi | undefined;
    protected sampleDataCreator: SampleDataCreator | undefined;
    readonly path: string;
    readonly base: string;
    readonly baseUri: string;
    constructor(path: string, sampleData?: SampleDataCreator);
    constructor(path: string, base?: string, sampleData?: SampleDataCreator);
    protected getSampleData(): SampleDataApi | undefined;
    protected getRequestUri(action: string, baseUri: string | undefined): string;
    observe<T>(action: string, params?: any, data?: any, method?: HttpRequestMethod, options?: AjaxRequest, baseUri?: string): Observable<T>;
    getObservable<T>(action: string, params?: any, options?: AjaxRequest, baseUri?: string): Observable<T>;
    postObservable<T>(action: string, data?: any, params?: any, options?: AjaxRequest, baseUri?: string): Observable<T>;
    getSampleStoreValue<T, TStore extends SampleDataStore>(name: string, selector: (data: TStore) => T): T | undefined;
}
