Object.defineProperty(exports, "__esModule", { value: true });
var Utils_1 = require("../../Utils");
var Logging_1 = require("../../Utils/Logging");
var WebRx_1 = require("../../WebRx");
var BaseSampleDataStore = /** @class */ (function () {
    function BaseSampleDataStore(enableAlerts) {
        if (enableAlerts === void 0) { enableAlerts = false; }
        this.enableAlerts = enableAlerts;
        this.actions = {};
        this.logger = Logging_1.getLogger(BaseSampleDataStore.displayName);
        this.wx = WebRx_1.wx;
    }
    BaseSampleDataStore.prototype.connect = function (action, api, thisArg) {
        if (thisArg === void 0) { thisArg = this; }
        this.actions[action] = function (params) {
            if (params === void 0) { params = {}; }
            this.createAlert(action, params);
            return api.apply(thisArg, arguments);
        }.bind(this);
    };
    BaseSampleDataStore.prototype.createAlert = function (action, params) {
        if (params === void 0) { params = {}; }
        if (this.enableAlerts) {
            Utils_1.Alert.create(JSON.stringify(params, null, 2), "SampleDataStore API Call: " + action);
        }
    };
    BaseSampleDataStore.displayName = 'BaseSampleDataStore';
    return BaseSampleDataStore;
}());
exports.BaseSampleDataStore = BaseSampleDataStore;
//# sourceMappingURL=BaseSampleDataStore.js.map