import { Observable } from 'rxjs';
import { Logger } from '../../Utils/Logging';
import { SampleDataActionSet, SampleDataApi, SampleDataStore } from '../Interfaces';
export declare class ObservableSampleDataApi implements SampleDataApi {
    static displayName: string;
    protected readonly logger: Logger;
    protected readonly stores: StringMap<SampleDataStore>;
    protected readonly actions: SampleDataActionSet;
    protected readonly delay: number;
    constructor(...stores: SampleDataStore[]);
    constructor(delay: number, ...stores: SampleDataStore[]);
    protected addStore(store: SampleDataStore): void;
    observe<T>(action: string, params?: any, data?: any, cloneResult?: boolean): Observable<T>;
    getStoreValue<T, TStore extends SampleDataStore>(name: string, selector: (store: TStore) => T, cloneResult?: boolean): T | undefined;
}
