import { BaseLogger, MessageDelegate } from '../Logger';
import { LogLevel } from '../LogLevel';
import { LogManager } from '../LogManager';
export declare type DelegateLoggerAction = (logger: DelegateLogger, level: LogLevel, text: string, args: any[]) => void;
export declare class DelegateLogger extends BaseLogger {
    private readonly action;
    constructor(action: DelegateLoggerAction, name: string, level: LogLevel);
    log(level: LogLevel | number, textOrFn: string | MessageDelegate, ...args: any[]): void;
}
export declare class DelegateLogManager implements LogManager {
    defaultLevel: LogLevel;
    private readonly action;
    constructor(action: (manager: DelegateLogManager) => DelegateLoggerAction, defaultLevel: LogLevel);
    getLogger(name: string, level?: LogLevel): DelegateLogger;
}
