// tslint:disable:max-classes-per-file
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Logger_1 = require("../Logger");
var DelegateLogger = /** @class */ (function (_super) {
    tslib_1.__extends(DelegateLogger, _super);
    function DelegateLogger(action, name, level) {
        var _this = _super.call(this, name, level) || this;
        _this.action = action;
        return _this;
    }
    DelegateLogger.prototype.log = function (level, textOrFn) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        if (this.isEnabledFor(level)) {
            if (textOrFn instanceof Function) {
                this.action(this, level, textOrFn(), args);
            }
            else {
                this.action(this, level, textOrFn.toString(), args);
            }
        }
    };
    return DelegateLogger;
}(Logger_1.BaseLogger));
exports.DelegateLogger = DelegateLogger;
var DelegateLogManager = /** @class */ (function () {
    function DelegateLogManager(action, defaultLevel) {
        this.defaultLevel = defaultLevel;
        this.action = action(this);
    }
    DelegateLogManager.prototype.getLogger = function (name, level) {
        return new DelegateLogger(this.action, name, level == null ? this.defaultLevel : level);
    };
    return DelegateLogManager;
}());
exports.DelegateLogManager = DelegateLogManager;
//# sourceMappingURL=Delegate.js.map