Object.defineProperty(exports, "__esModule", { value: true });
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["All"] = 0] = "All";
    LogLevel[LogLevel["Trace"] = 10] = "Trace";
    LogLevel[LogLevel["Debug"] = 20] = "Debug";
    LogLevel[LogLevel["Info"] = 30] = "Info";
    LogLevel[LogLevel["Warn"] = 40] = "Warn";
    LogLevel[LogLevel["Error"] = 50] = "Error";
    LogLevel[LogLevel["Fatal"] = 60] = "Fatal";
    LogLevel[LogLevel["Off"] = 99] = "Off";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
function getLevelName(level) {
    var name = 'Off  ';
    if (level >= LogLevel.Fatal) {
        name = 'Fatal';
    }
    else if (level >= LogLevel.Error) {
        name = 'Error';
    }
    else if (level >= LogLevel.Warn) {
        name = 'Warn ';
    }
    else if (level >= LogLevel.Info) {
        name = 'Info ';
    }
    else if (level >= LogLevel.Debug) {
        name = 'Debug';
    }
    else if (level >= LogLevel.Trace) {
        name = 'Trace';
    }
    else {
        name = 'All  ';
    }
    return name;
}
exports.getLevelName = getLevelName;
function getDefaultLogLevel(isTest, isDebug) {
    if (isTest === void 0) { isTest = false; }
    if (isDebug === void 0) { isDebug = false; }
    var defaultLevel = LogLevel.Info;
    // allow build to override default value
    if (TEST) {
        isTest = true;
    }
    // allow build to override default value
    if (DEBUG) {
        isDebug = true;
    }
    if (isTest) {
        defaultLevel = LogLevel.Off;
    }
    else if (isDebug) {
        defaultLevel = LogLevel.Debug;
    }
    return defaultLevel;
}
exports.getDefaultLogLevel = getDefaultLogLevel;
exports.DefaultLogLevel = getDefaultLogLevel();
//# sourceMappingURL=LogLevel.js.map