Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var LogLevel_1 = require("./LogLevel");
var BaseLogger = /** @class */ (function () {
    function BaseLogger(name, level) {
        this.name = name;
        this.level = level;
    }
    BaseLogger.prototype.isEnabledFor = function (level) {
        return this.level <= level;
    };
    BaseLogger.prototype.trace = function (textOrFn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (textOrFn instanceof Function) {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Trace, textOrFn], args));
        }
        else {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Trace, textOrFn.toString()], args));
        }
    };
    BaseLogger.prototype.debug = function (textOrFn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (textOrFn instanceof Function) {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Debug, textOrFn], args));
        }
        else {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Debug, textOrFn.toString()], args));
        }
    };
    BaseLogger.prototype.info = function (textOrFn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (textOrFn instanceof Function) {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Info, textOrFn], args));
        }
        else {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Info, textOrFn.toString()], args));
        }
    };
    BaseLogger.prototype.warn = function (textOrFn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (textOrFn instanceof Function) {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Warn, textOrFn], args));
        }
        else {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Warn, textOrFn.toString()], args));
        }
    };
    BaseLogger.prototype.error = function (textOrFn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (textOrFn instanceof Function) {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Error, textOrFn], args));
        }
        else {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Error, textOrFn.toString()], args));
        }
    };
    BaseLogger.prototype.fatal = function (textOrFn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (textOrFn instanceof Function) {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Fatal, textOrFn], args));
        }
        else {
            this.log.apply(this, tslib_1.__spread([LogLevel_1.LogLevel.Fatal, textOrFn.toString()], args));
        }
    };
    return BaseLogger;
}());
exports.BaseLogger = BaseLogger;
//# sourceMappingURL=Logger.js.map