Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var Logging_1 = require("./Logging");
var PubSub = /** @class */ (function (_super) {
    tslib_1.__extends(PubSub, _super);
    function PubSub() {
        var _this = _super.call(this) || this;
        _this.logger = Logging_1.getLogger(PubSub.displayName);
        _this.map = {};
        return _this;
    }
    PubSub.prototype.getSubject = function (key) {
        var subject = this.map[key];
        if (subject == null) {
            subject = new rxjs_1.Subject();
            this.map[key] = subject;
            this.add(subject);
        }
        return subject;
    };
    PubSub.prototype.observe = function (key) {
        return this.getSubject(key).asObservable();
    };
    PubSub.prototype.subscribe = function (key, onNext, onError, onCompleted) {
        var _this = this;
        if (onError == null) {
            onError = function (e) {
                _this.logger.error('PubSub Error', e);
            };
        }
        return this.observe(key).subscribe(onNext, onError, onCompleted);
    };
    PubSub.prototype.publish = function (key, arg) {
        this.getSubject(key).next(arg);
    };
    PubSub.displayName = 'PubSub';
    return PubSub;
}(rxjs_1.Subscription));
exports.PubSub = PubSub;
exports.Default = new PubSub();
function observe(key) {
    return exports.Default.observe(key);
}
exports.observe = observe;
function subscribe(key, onNext, onError, onCompleted) {
    return exports.Default.subscribe(key, onNext, onError, onCompleted);
}
exports.subscribe = subscribe;
function publish(key, arg) {
    exports.Default.publish(key, arg);
}
exports.publish = publish;
//# sourceMappingURL=PubSub.js.map