import { BehaviorSubject, Observable, Subject, Subscription } from 'rxjs';
import { Property } from './Interfaces';
export declare class ObservableProperty<T> extends Subscription implements Property<T> {
    protected source: Observable<T>;
    protected changedSubject: BehaviorSubject<T>;
    protected thrownErrorsSubject: Subject<Error>;
    constructor(initialValue?: T, compare?: (x: T, y: T) => boolean, keySelector?: (x: T) => any, source?: Observable<T>);
    readonly isReadOnly: boolean;
    value: T;
    readonly changed: Observable<T>;
    readonly thrownErrors: Observable<Error>;
    isProperty(): boolean;
}
export declare function property<T>(initialValue?: T, source?: Observable<T>): Property<T>;
export declare function property<T>(initialValue?: T, compare?: boolean | ((x: T, y: T) => boolean), source?: Observable<T>): Property<T>;
export declare function property<T>(initialValue?: T, compare?: boolean | ((x: T, y: T) => boolean), keySelector?: (x: T) => any, source?: Observable<T>): Property<T>;
