import * as utils from '../Utils';
import { command } from './Command';
import { property } from './Property';
import { asObservable, getObservable, getObservableOrAlert, getObservableResultOrAlert, getProperty, handleError, isAsyncIterable, isCommand, isIterable, isObservable, isObserver, isProperty, isSubject, isSubscription, logError, logMemberObservables, logObservable, subscribeOrAlert } from './Utils';
import { whenAny } from './WhenAny';
export declare function create(): {
    isIterable: typeof isIterable;
    isAsyncIterable: typeof isAsyncIterable;
    isSubscription: typeof isSubscription;
    isObservable: typeof isObservable;
    isObserver: typeof isObserver;
    isSubject: typeof isSubject;
    isProperty: typeof isProperty;
    isCommand: typeof isCommand;
    asObservable: typeof asObservable;
    getObservable: typeof getObservable;
    getProperty: typeof getProperty;
    handleError: typeof handleError;
    logError: typeof logError;
    property: typeof property;
    command: typeof command;
    whenAny: typeof whenAny;
    logObservable: typeof logObservable;
    logMemberObservables: typeof logMemberObservables;
    getObservableOrAlert: typeof getObservableOrAlert;
    getObservableResultOrAlert: typeof getObservableResultOrAlert;
    subscribeOrAlert: typeof subscribeOrAlert;
    utils: typeof utils;
};
export declare const wx: {
    isIterable: typeof isIterable;
    isAsyncIterable: typeof isAsyncIterable;
    isSubscription: typeof isSubscription;
    isObservable: typeof isObservable;
    isObserver: typeof isObserver;
    isSubject: typeof isSubject;
    isProperty: typeof isProperty;
    isCommand: typeof isCommand;
    asObservable: typeof asObservable;
    getObservable: typeof getObservable;
    getProperty: typeof getProperty;
    handleError: typeof handleError;
    logError: typeof logError;
    property: typeof property;
    command: typeof command;
    whenAny: typeof whenAny;
    logObservable: typeof logObservable;
    logMemberObservables: typeof logMemberObservables;
    getObservableOrAlert: typeof getObservableOrAlert;
    getObservableResultOrAlert: typeof getObservableResultOrAlert;
    subscribeOrAlert: typeof subscribeOrAlert;
    utils: typeof utils;
};
export declare type WebRxStatic = typeof wx;
export declare function inject<T extends {}>(target: T, wxStatic?: WebRxStatic): T & {
    isIterable: typeof isIterable;
    isAsyncIterable: typeof isAsyncIterable;
    isSubscription: typeof isSubscription;
    isObservable: typeof isObservable;
    isObserver: typeof isObserver;
    isSubject: typeof isSubject;
    isProperty: typeof isProperty;
    isCommand: typeof isCommand;
    asObservable: typeof asObservable;
    getObservable: typeof getObservable;
    getProperty: typeof getProperty;
    handleError: typeof handleError;
    logError: typeof logError;
    property: typeof property;
    command: typeof command;
    whenAny: typeof whenAny;
    logObservable: typeof logObservable;
    logMemberObservables: typeof logMemberObservables;
    getObservableOrAlert: typeof getObservableOrAlert;
    getObservableResultOrAlert: typeof getObservableResultOrAlert;
    subscribeOrAlert: typeof subscribeOrAlert;
    utils: typeof utils;
};
