import { isAsyncIterable, isIterable } from 'ix/internal/isiterable';
import { Observable, Observer, Subject, Subscription } from 'rxjs';
import { AnonymousSubscription } from 'rxjs/Subscription';
import { Logging } from '../Utils';
import { Command, ObservableLike, ObservableOrValue, Property } from './Interfaces';
export { isIterable, isAsyncIterable };
export declare function isSubscription(value: any): value is AnonymousSubscription;
export declare function isObservable<T>(value: any): value is Observable<T>;
export declare function isObserver<T>(value: any): value is Observer<T>;
export declare function isSubject<T>(value: any): value is Subject<T>;
export declare function isProperty<T>(value: any): value is Property<T>;
export declare function isCommand<T>(value: any): value is Command<T>;
export declare function asObservable<T>(value: ObservableOrValue<T>): Observable<T>;
export declare function getObservable<T>(observableLike: ObservableLike<T> | undefined): Observable<T>;
export declare function getProperty<T>(observableLike: ObservableLike<T> | undefined, initialValue?: T, compare?: boolean | ((x: T, y: T) => boolean), keySelector?: (x: T) => any): Property<T>;
export declare function handleError(e: any, ...optionalParams: any[]): void;
export declare function logError(err: Error, ...optionalParams: any[]): void;
export declare function logObservable(logger: Logging.Logger, observable: Observable<any>, name: string): Subscription;
export declare function logMemberObservables(logger: Logging.Logger, source: StringMap<any>): Subscription[];
export declare function getObservableOrAlert<T, TError = Error>(observableFactory: () => Observable<T>, header?: string, style?: string, timeout?: number, errorFormatter?: (e: TError) => string, errorResult?: Observable<T>): Observable<T>;
export declare function getObservableResultOrAlert<TResult, TError = Error>(resultFactory: () => TResult, header?: string, style?: string, timeout?: number, errorFormatter?: (e: TError) => string, errorResult?: Observable<TResult>): Observable<TResult>;
export declare function subscribeOrAlert<T, TError = Error>(observableFactory: () => Observable<T>, header: string, onNext: (value: T) => void, style?: string, timeout?: number, errorFormatter?: (e: TError) => string, errorResult?: Observable<T>): Subscription;
