Object.defineProperty(exports, "__esModule", { value: true });
function getValueOrDefault(value, envValue, defaultValue) {
    try {
        var val = value();
        if (val != null) {
            return val;
        }
    }
    catch (_a) {
        // it's possible that the value selector uses a global variable that isn't defined
    }
    if (global.process != null && global.process.env != null) {
        var val = envValue(global.process.env);
        if (val != null) {
            return val;
        }
    }
    return defaultValue;
}
// check to see if we should override the default DEBUG mode
var debugOverride = window && window.location
    ? (window.location.search || '')
        .substr(1)
        .split('&')
        .map(function (x) { return x.split('='); })
        .filter(function (x) { return (x[0] || '').toLowerCase() === 'debug'; })
        .map(function (x) { return (x[1] ? true : false); })
        .pop()
    : undefined;
// we need to untype global to allow us to inject fallbacks
var g = global;
// if we don't have a webpack environment then we'll fallback onto defaults
g.DEBUG = getValueOrDefault(function () { return (debugOverride == null ? DEBUG : debugOverride); }, function (env) { return env.NODE_ENV === 'debug'; }, false);
g.PRODUCTION = getValueOrDefault(function () { return PRODUCTION; }, function (env) { return env.NODE_ENV === 'production'; }, true);
g.TEST = getValueOrDefault(function () { return TEST; }, function (env) { return env.NODE_ENV === 'test'; }, false);
g.WEBPACK_DEV_SERVER = getValueOrDefault(function () { return WEBPACK_DEV_SERVER; }, function (env) { return env.NODE_ENV === 'webpack'; }, false);
g.VERSION = getValueOrDefault(function () { return VERSION; }, function (env) { return env.VERSION; }, 'BUILD');
// export webrx-react version string
var version_1 = require("./version");
exports.version = version_1.version;
//# sourceMappingURL=globals.js.map