Object.defineProperty(exports, "__esModule", { value: true });
// import globals
var globals_1 = require("./globals");
exports.version = globals_1.version;
// import all custom styles
require("./Style/App.less");
// import core-js to standardize the ECMAScript api across browsers
require("core-js");
// apply augmentations
require("./types/augmentations");
// import extensions
require("./Extensions");
var Logging_1 = require("./Utils/Logging");
// inform the user which version we are using
Logging_1.getLogger('webrx-react').info("Initializing webrx-react (v" + globals_1.version + ")");
// import webrx-react helper submodules
var Events = require("./Events");
exports.Events = Events;
var Utils_1 = require("./Utils");
exports.Alert = Utils_1.Alert;
exports.Compare = Utils_1.Compare;
exports.Logging = Utils_1.Logging;
exports.Moment = Utils_1.Moment;
exports.PubSub = Utils_1.PubSub;
// import WebRx framework
var wx = require("./WebRx");
exports.wx = wx;
// import webrx-react framework submodules
var Components = require("./Components");
exports.Components = Components;
var Routing = require("./Routing");
exports.Routing = Routing;
var Stores = require("./Stores");
exports.Stores = Stores;
//# sourceMappingURL=webrx-react.js.map